/*
 * Filename ByteArrayDataSource.java   Auther: Henrik Baastrup (c) 2001
 *
 * This software is licensed under the GNU LGPL (Lesser general Public License):
 *   http://www.gnu.org/copyleft/lesser.html
 *
 */

package com.hbaastrup.AutoReportGenerator;

import java.io.InputStream;
import java.io.OutputStream;
import java.io.IOException;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.FileNotFoundException;
import javax.activation.DataSource;

public class ByteArrayDataSource implements DataSource
{
    byte[] bytes;
    String contentType;
    String name;
    boolean selected = true;

    public ByteArrayDataSource(byte[] bytes, String contentType, String name)
    {
        this.bytes = bytes;
        if (null == contentType) this.contentType = "application/octet-stream";
        else this.contentType = contentType;
        this.name = name;
    }

    public String getContentType() {return contentType;}

    public String getName() {return name;}

    public int getLength() {return bytes.length-2;}

    public InputStream getInputStream()
    {
        return new ByteArrayInputStream(bytes, 0, bytes.length-2);
    }//getInputStream

    public OutputStream getOutputStream() throws java.io.IOException
    {
        throw new FileNotFoundException();
    }//getOutputStream

    public void setSelected(boolean b) {selected = b;}
    public boolean getSelected() {return selected;}
    public boolean isSelected() {return selected;}
}//ByteArrayDataSource
