/*
 * Filename ControlServlet.java   Auther: Henrik Baastrup (c) 2001
 *
 * This software is licensed under the GNU LGPL (Lesser general Public License):
 *   http://www.gnu.org/copyleft/lesser.html
 */

package com.hbaastrup.AutoReportGenerator;

import java.io.IOException;
import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpSession;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class ControlServlet extends HttpServlet
{
    private static ControlServlet mySelfInstance = null;
    private String jdbcUrl = "";
    private String jdbcDriver = "";
    private String jdbcUser = "";
    private String jdbcPassword = "";

    public ControlServlet()
    {
        mySelfInstance = this;
    }//ControlServlet

    public void init(ServletConfig config) throws ServletException
    {
        String str;

System.out.println("ControlServlet.init()");
        if ((str=config.getInitParameter("LogName"))!=null) {
//            HbaLog.setFileName(str);
        }
        if ((str=config.getInitParameter("JdbcUrl"))!=null) {
            jdbcUrl = new String(str);
        }
        if ((str=config.getInitParameter("JdbcDriver"))!=null) {
            jdbcDriver = new String(str);
        }
        if ((str=config.getInitParameter("JdbcUser"))!=null) {
            jdbcUser = new String(str);
        }
        if ((str=config.getInitParameter("JdbcPassword"))!=null) {
            jdbcPassword = new String(str);
        }
        Log.log("com.hbaastrup.AutoReportGenerator.ControlServlet.init(): Init");
    }//init
    
    protected void doIt(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException
    {
System.out.println("The ControlServlet was called");
        request.getRequestDispatcher("/jsp/index.html").forward(request, response);
    }//doIt

    protected void doGet(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException
    {
        doIt(request, response);
    }//doGet

    protected void doPost(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException
    {
        doIt(request, response);
    }// doPost

    public static ControlServlet getInstance() {return mySelfInstance;}

    public String getJdbcUrl() {return jdbcUrl;}
    public String getJdbcDriver() {return jdbcDriver;}
    public String getJdbcUser() {return jdbcUser;}
    public String getJdbcPassword() {return jdbcPassword;}

}//ControlServlet
