/*
 * Filename ReportList.java   Auther: Henrik Baastrup (c) 2001
 *
 * This software is licensed under the GNU LGPL (Lesser general Public License):
 *   http://www.gnu.org/copyleft/lesser.html
 */

package com.hbaastrup.AutoReportGenerator;

import java.io.*;
import java.sql.*;
import java.util.*;
import java.text.*;

public class ReportList {
    private java.sql.Connection dbConnection = null;
    private java.sql.Statement dbStatement = null;

    public ReportList() {
        String jdbcUrl = "";
        String jdbcDriver = "";
        String jdbcUser = "";
        String jdbcPassword = "";
        ControlServlet controlServlet = ControlServlet.getInstance();

        jdbcUrl = controlServlet.getJdbcUrl();
        jdbcDriver = controlServlet.getJdbcDriver();
        jdbcUser = controlServlet.getJdbcUser();
        jdbcPassword = controlServlet.getJdbcPassword();
        try {
            Class.forName(jdbcDriver);
            if ((dbConnection=DriverManager.getConnection(jdbcUrl, jdbcUser, jdbcPassword))==null) {
                Log.log("ReportList: DriverManager.getConnection() returned null");
                return;
            }
            dbConnection.setAutoCommit(true);
            if ((dbStatement=dbConnection.createStatement())==null) {
                Log.log("ReportList: Connection.createStatement() returned null");
                return;
            }
        }
        catch (SecurityException ex) {
            Log.log("ReportList: "+ex);
            return;
        }
        catch (ClassNotFoundException ex) {
            Log.log("ReportList: "+ex);
            return;
        }
        catch (SQLException ex) {
            Log.log("ReportList: "+ex);
            return;
        }
    }

    public String[] getSprList()
    {
        ResultSet rSet;
        Timestamp tm;
        SimpleDateFormat sdf = new SimpleDateFormat("dd/MM/yyyy");
        Vector vec = new Vector();
        String qStr, str, rStr[];
        int i;

        if (dbStatement==null) return null;
        qStr = "Select * from SoftwareProblemReport";

        try {
            if ((rSet=dbStatement.executeQuery(qStr))==null) return null;
            while (rSet.next()) {
                i = rSet.getInt("sprNo");
                str = "<a href='/arg/servlet/editor?repNo="+i+"&ForwardJsp=/jsp/sprInput.jsp&action=load' target='input_area'><b>Spr No:</b> "+i+"</a>";
                str += "</a> "+rSet.getString("title");
                tm = rSet.getTimestamp("date");
                str += " ("+sdf.format(tm)+")";
                str += " ["+rSet.getString("status").trim()+"]";
                vec.add(str);
            }
            rSet.close();
        } catch (SQLException ex) {
            Log.log("ReportList.getSprList(): "+ex);
            return null;
        }

        rStr = new String[vec.size()];
        Enumeration enum = vec.elements();
        i = 0;
        while (enum.hasMoreElements()) {
            rStr[i] = (String)enum.nextElement();
            i++;
        }
        return rStr;
    }

    public String[] getScrList()
    {
        ResultSet rSet;
        Timestamp tm;
        SimpleDateFormat sdf = new SimpleDateFormat("dd/MM/yyyy");
        Vector vec = new Vector(0);
        String qStr, str, rStr[];
        int i;

        if (dbStatement==null) return null;
        qStr = "Select * from SoftwareChangeRequest";

        try {
            if ((rSet=dbStatement.executeQuery(qStr))==null) return null;
            while (rSet.next()) {
                i = rSet.getInt("scrNo");
                str = "<a href='/arg/servlet/editor?repNo="+i+"&ForwardJsp=/jsp/scrInput.jsp&action=load' target='input_area'><b>Scr No:</b> "+i+"</a>";
                str += " "+rSet.getString("title");
                tm = rSet.getTimestamp("date");
                str += " ("+sdf.format(tm)+")";
                str += " ["+rSet.getString("status").trim()+"]";
                vec.add(str);
            }
            rSet.close();
        } catch (SQLException ex) {
            Log.log("ReportList.getScrList(): "+ex);
System.out.println(ex);
            return null;
        }

        rStr = new String[vec.size()];
        Enumeration enum = vec.elements();
        i = 0;
        while (enum.hasMoreElements()) {
            rStr[i] = (String)enum.nextElement();
            i++;
        }
        return rStr;
    }

}//ReportList
