/*
 * Filename ReportMailerServlet.java   Auther: Henrik Baastrup (c) 2001
 *
 * This software is licensed under the GNU LGPL (Lesser general Public License):
 *   http://www.gnu.org/copyleft/lesser.html
 *
 */
package com.hbaastrup.AutoReportGenerator;


import java.io.PrintWriter;
import java.io.IOException;
import java.io.ByteArrayOutputStream;
import java.util.Vector;
import java.util.StringTokenizer;
import java.util.Properties;
import java.net.InetAddress;
import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletInputStream;
import javax.servlet.ServletContext;
import javax.servlet.RequestDispatcher;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpSession;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.mail.Session;
import javax.mail.Message;
import javax.mail.Transport;
import javax.mail.internet.InternetAddress;
import javax.mail.internet.MimeMessage;
import javax.mail.internet.MimeMultipart;
import javax.mail.internet.MimeBodyPart;
import javax.activation.DataHandler;

class ParameterField
{
    public String name = "";
    public String value = "";
}//ParameterField

public class ReportMailerServlet extends HttpServlet
{
    private static ReportMailerServlet mySelfInstance = null;
    private String smtpHost = null;
    private String defaultRecipientAddress = null;
    private String defaultSenderAddress = null;
    private String forwardToJsp = "";
    private Vector attachmentFields = new Vector(0);
    private Vector parameterFields = new Vector(0);
    private String date = null;
    private String originator = null;
    private String status = null;
    private String title = null;
    private String swVersion = null;
    private int priority = 0;
    private String description = null;
    private String changeRequired = null;
    private String environment = null;
    private String responsibleStaff = null;
    private String solution = null;
    private String decision = null;
    private String startDate = null;
    private String endDate = null;
    private String manpower = null;
    private String recipientAddr = null;
    private String senderAddr = null;
    private String subject = null;
    private String ccAddr = null;
    private boolean doSend = false;
    private boolean haveError = false;
    private boolean isSend = false;
    private String message = "";
    private int language = 0;
    private int problemType = 0;

    public void init(ServletConfig config) throws ServletException
    {
        String str;

        super.init(config);

        if ((str=config.getInitParameter("SmtpHost"))!=null) {
            smtpHost = new String(str);
        }
        if ((str=config.getInitParameter("DefaultRecipientAddress"))!=null) {
            defaultRecipientAddress = new String(str);
        }
        if ((str=config.getInitParameter("DefaultSenderAddress"))!=null) {
            defaultSenderAddress = new String(str);
        }
        if ((str=config.getInitParameter("ForwardJsp"))!=null) {
            forwardToJsp = new String(str);
        }
System.out.println("ProblemReportMailer.init(): "+smtpHost+"   "+defaultRecipientAddress+"   "+defaultSenderAddress+"  "+forwardToJsp);
    }//init

    protected void doGet(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        java.io.PrintWriter out;
        String requested;
        String action = "";

        response.setContentType("text/html");
        out = response.getWriter();
        
        if ((requested=request.getParameter("action"))!=null) action = requested.trim();
        if ((requested=request.getParameter("date"))!=null) date = requested.trim();
        if ((requested=request.getParameter("originator"))!=null) originator = requested.trim();
        if ((requested=request.getParameter("status"))!=null) status = requested.trim();
        if ((requested=request.getParameter("title"))!=null) title = requested.trim();
        if ((requested=request.getParameter("swVersion"))!=null) swVersion = requested.trim();
        if ((requested=request.getParameter("priority"))!=null) {
            if (requested.equals("Routine")) priority = 1;
            else if (requested.equals("Urgent")) priority = 2;
            else if (requested.equals("Critical")) priority = 3;
            else priority = 0;
        }
        if ((requested=request.getParameter("description"))!=null) description = requested.trim();
        if ((requested=request.getParameter("changeRequired"))!=null) changeRequired = requested.trim();
        if ((requested=request.getParameter("environment"))!=null) environment = requested.trim();
        if ((requested=request.getParameter("responsibleStaff"))!=null) responsibleStaff = requested.trim();
        if ((requested=request.getParameter("decision"))!=null) decision = requested.trim();
        if ((requested=request.getParameter("startDate"))!=null) startDate = requested.trim();
        if ((requested=request.getParameter("endDate"))!=null) endDate = requested.trim();
        if ((requested=request.getParameter("manpower"))!=null) manpower = requested.trim();
        if ((requested=request.getParameter("solution"))!=null) solution = requested.trim();
        if ((requested=request.getParameter("recipientAddr"))!=null) recipientAddr = requested.trim();
        if ((requested=request.getParameter("ccAddr"))!=null) ccAddr = requested.trim();
        if ((requested=request.getParameter("senderAddr"))!=null) senderAddr = requested.trim();
        if ((requested=request.getParameter("ForwardJsp"))!=null) forwardToJsp = requested.trim();

        for (int i=0; i<attachmentFields.size(); i++) {
            ByteArrayDataSource ds = (ByteArrayDataSource)attachmentFields.get(i);
            if ((requested=request.getParameter("attachmentFileSel"+i))!=null) {
                ds.setSelected(true);
            }
            else {
                ds.setSelected(false);
            }
        }

        if (forwardToJsp.indexOf("spr")>=0) problemType = 1;
        else if (forwardToJsp.indexOf("scr")>=0) problemType = 2;
        else problemType = 0;

System.out.println("Get Forward to: "+forwardToJsp+ "  problemType="+problemType);
        ServletContext sc = getServletContext();
        if (action.equals("Attach Files")) {
            attachFiles(out);
        }
        else if (action.equals("Allega File")) {
            language = 1;
            attachFilesIt(out);
        }
        else if (action.equals("Send") || action.equals("Invia")) {
            parameterCheck();
            if (!haveError) sendMessage();
            if (!haveError) {
                if (language==1) messageSendIt(out);
                else messageSend(out);
                resetAll(request);
            }
            else {
                setPageParameters(request);
                RequestDispatcher rd = sc.getRequestDispatcher(forwardToJsp);
                rd.forward(request, response);
            }
        }
        else {
            setPageParameters(request);
            RequestDispatcher rd = sc.getRequestDispatcher(forwardToJsp);
            rd.forward(request, response);
        }
        out.close();
    } //doGet

    protected void doPost(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
//        processRequest(request, response);
        java.io.PrintWriter out;
        String action = "";
        response.setContentType("text/html");
        out = response.getWriter();
        doUpload(request, response);
        for (int i=0; i<parameterFields.size(); i++) {
            ParameterField pf = (ParameterField)parameterFields.get(i);
            if (pf.name.equals("action")) action = pf.value;
            else if (pf.name.equals("date")) date = pf.value.trim();
            else if (pf.name.equals("originator")) originator = pf.value.trim();
            else if (pf.name.equals("status")) status = pf.value.trim();
            else if (pf.name.equals("title")) title = pf.value.trim();
            else if (pf.name.equals("swVersion")) swVersion = pf.value.trim();
            else if (pf.name.equals("priority")) {
                if (pf.value.equals("Routine")) priority = 1;
                else if (pf.value.equals("Urgent")) priority = 2;
                else if (pf.value.equals("Critical")) priority = 3;
                else priority = 0;
            }
            else if (pf.name.equals("description")) description = pf.value.trim();
            else if (pf.name.equals("changeRequired")) changeRequired = pf.value.trim();
            else if (pf.name.equals("environment")) environment = pf.value.trim();
            else if (pf.name.equals("responsibleStaff")) responsibleStaff = pf.value.trim();
            else if (pf.name.equals("decision")) decision = pf.value.trim();
            else if (pf.name.equals("startDate")) startDate = pf.value.trim();
            else if (pf.name.equals("endDate")) endDate = pf.value.trim();
            else if (pf.name.equals("manpower")) manpower = pf.value.trim();
            else if (pf.name.equals("solution")) solution = pf.value.trim();
            else if (pf.name.equals("recipientAddr")) recipientAddr = pf.value.trim();
            else if (pf.name.equals("ccAddr")) ccAddr = pf.value.trim();
            else if (pf.name.equals("senderAddr")) senderAddr = pf.value.trim();
            else if (pf.name.equals("ForwardJsp")) forwardToJsp = pf.value.trim();
        }

        if (forwardToJsp.indexOf("spr")>=0) problemType = 1;
        else if (forwardToJsp.indexOf("scr")>=0) problemType = 2;
        else problemType = 0;

System.out.println("Post Forward to: "+forwardToJsp+ "  problemType="+problemType);
        ServletContext sc = getServletContext();
        if (action.equals("Cancel") || action.equals("Anulla")) {
            attachmentFields = new Vector(0);
            setPageParameters(request);
            RequestDispatcher rd = sc.getRequestDispatcher(forwardToJsp);
            rd.forward(request, response);
        }
        else if (action.equals("Attach files") || action.equals("Allega file")) {
            setPageParameters(request);
            RequestDispatcher rd = sc.getRequestDispatcher(forwardToJsp);
            rd.forward(request, response);
        }
        else {
            if (1==language) attachFilesIt(out);
            else attachFiles(out);
        }
        out.close();
    }//doPost

    public void resetAll(HttpServletRequest req)
    {
        HttpSession session = req.getSession(false);
        if (req!=null) {
            for (int i=0; i<attachmentFields.size(); i++) {
                ByteArrayDataSource ds = (ByteArrayDataSource)attachmentFields.get(i);
                session.removeAttribute("attachmentFile"+i);
                session.removeAttribute("attachmentFileSel"+i);
            }
             session.removeAttribute("originator");
             session.removeAttribute("status");
             session.removeAttribute("date");
             session.removeAttribute("title");
             session.removeAttribute("swVersion");
             session.removeAttribute("priority");
             session.removeAttribute("description");
             session.removeAttribute("changeRequired");
             session.removeAttribute("environment");
             session.removeAttribute("responsibleStaff");
             session.removeAttribute("decision");
             session.removeAttribute("startDate");
             session.removeAttribute("endDate");
             session.removeAttribute("manpower");
             session.removeAttribute("solution");
             session.removeAttribute("recipientAddr");
             session.removeAttribute("senderAddr");
             session.removeAttribute("ccAddr");
             session.removeAttribute("haveError");
        }
        attachmentFields = new Vector(0);
        parameterFields = new Vector(0);
        date = null;
        originator = null;
        status = null;
        title = null;
        swVersion = null;
        priority = 0;
        description = null;
        changeRequired = null;
        environment = null;
        responsibleStaff = null;
        solution = null;
        decision = null;
        solution = null;
        startDate = null;
        endDate = null;
        manpower = null;
        recipientAddr = null;
        senderAddr = null;
        subject = null;
        ccAddr = null;
        doSend = false;
        haveError = false;
        isSend = false;
        message = "";
    }//resetAll

    public String getServletInfo() {
        return "Software Problem Report Servlet";
    }

    public String getDefaultRecipientAddress() {return defaultRecipientAddress;}

    public String getDefaultSenderAddress() {return defaultSenderAddress;}

    public String getForwardToJsp() {return forwardToJsp;}
    public void setForwardToJsp(String s) {forwardToJsp = s;}

    public void messageSend(java.io.PrintWriter out)
    {
            out.println("<html>");
            out.println("<head>");
            out.println("</head>");
            out.println("<body>");
            out.println("<h1>Mail send!</h1><br>");
            out.println("</body>");
            out.println("</html>");
    }//messageSend
    
    public void messageSendIt(java.io.PrintWriter out)
    {
            out.println("<html>");
            out.println("<head>");
            out.println("</head>");
            out.println("<body>");
            out.println("<h1>Mail spedito!</h1><br>");
            out.println("</body>");
            out.println("</html>");
    }//messageSend
    
    private void attachFiles(java.io.PrintWriter out)
    {

            out.println("<html>");
            out.println("<head>");
            out.println("</head>");
            out.println("<body>");
            out.println("<h1>Attach files</h1><br>");
            out.println("<form method='post' enctype='multipart/form-data'>");
            out.println("");
            out.println("Look for file in: <input type='file' name='Attachment' size='50'>");
            out.println("<input type='submit' name='action' value='Add'><br>");
            out.println("To attach the files here blow to the message, <b>click here:</b> <input type='submit' name='action' value='Attach files'><br>");
            out.println("<input type='submit' name='action' value='Cancel'><br>");
            out.println("</form>");
            for (int i=0; i<attachmentFields.size(); i++) {
                ByteArrayDataSource ds = (ByteArrayDataSource)attachmentFields.get(i);
                out.println("Atachment: "+ds.getName()+" ("+ds.getLength()+" bytes)<br>");
            }
            out.println("</body>");
            out.println("</html>");
    }//attachFiles

    private void attachFilesIt(java.io.PrintWriter out)
    {

            out.println("<html>");
            out.println("<head>");
            out.println("</head>");
            out.println("<body>");
            out.println("<h1>Allega file</h1><br>");
            out.println("<form method='post' enctype='multipart/form-data'>");
            out.println("");
            out.println("Cerca file in: <input type='file' name='Attachment' size='50'>");
            out.println("<input type='submit' name='action' value='Allega'><br>");
            out.println("Per allegare al messaggio i file elencati qui sotto, <b>clica qui:</b> <input type='submit' name='action' value='Allega file'><br>");
            out.println("<input type='submit' name='action' value='Anulla'><br>");
            out.println("</form>");
            for (int i=0; i<attachmentFields.size(); i++) {
                ByteArrayDataSource ds = (ByteArrayDataSource)attachmentFields.get(i);
                out.println("File allegaro: "+ds.getName()+" ("+ds.getLength()+" bytes)<br>");
            }
            out.println("</body>");
            out.println("</html>");
    }//attachFiles

    private void doUpload(HttpServletRequest request, HttpServletResponse response)
    throws IOException
    {
        String boundary = request.getHeader("Content-Type");
        int pos = boundary.indexOf('=');
        boundary = boundary.substring(pos + 1);
        boundary = "--" + boundary;

        ServletInputStream in = request.getInputStream();
        byte[] bytes = new byte[512];
        int state = 0;
        ByteArrayOutputStream buffer = new ByteArrayOutputStream();
        String name = null,
               value = null,
               filename = null,
               contentType = null;

        parameterFields = new Vector(0);
        int i = in.readLine(bytes,0,512);
        while(-1 != i) {
            String st = new String(bytes,0,i);
            if(st.startsWith(boundary)) {
                state = 0;
                if(null != name) {
                    if(value != null) {
                        ParameterField pf = new ParameterField();
                        pf.name = name;
                        pf.value = new String(value.getBytes(),0,value.length()-2);// -2 to remove CR/LF
                        parameterFields.add(pf);// -2 to remove CR/LF
                    }
                    else if(buffer.size() > 2) {
                        ByteArrayDataSource ds = new ByteArrayDataSource(buffer.toByteArray(), contentType, filename);
                        attachmentFields.add(ds);
                    }
                    name = null;
                    value = null;
                    filename = null;
                    contentType = null;
                    buffer = new ByteArrayOutputStream();
                }
            }
            else if(st.startsWith("Content-Disposition: form-data") && state == 0)  {
                StringTokenizer tokenizer = new StringTokenizer(st,";=\"");
                while(tokenizer.hasMoreTokens()) {
                    String token = tokenizer.nextToken();
                    if(token.startsWith(" name")) {
                        name = tokenizer.nextToken();
                        state = 2;
                    }
                    else if(token.startsWith(" filename")) {
                        filename = tokenizer.nextToken();
                        StringTokenizer ftokenizer = new StringTokenizer(filename,"\\/:");
                        filename = ftokenizer.nextToken();
                        while(ftokenizer.hasMoreTokens()) filename = ftokenizer.nextToken();
                        state = 1;
                        break;
                    }
                }
            }
            else if(st.startsWith("Content-Type") && state == 1) {
                pos = st.indexOf(":");
                // + 2 to remove the space
                // - 2 to remove CR/LF
                contentType = st.substring(pos + 2,st.length() - 2);
            }
            else if(st.equals("\r\n") && state == 1) state = 3;
            else if(st.equals("\r\n") && state == 2) state = 4;
            else if(state == 4) value = value == null ? st : value + st;
            else if(state == 3) buffer.write(bytes,0,i);
            i = in.readLine(bytes,0,512);
        }
    }//doUpload
    
    private void setPageParameters(HttpServletRequest req)
    {
        HttpSession session = req.getSession(true);
        if (session==null) return;
        session.setAttribute("sessionType","SendMail");
        if (date!=null) session.setAttribute("date",date);
        if (originator!=null) session.setAttribute("originator",originator);
        if (status!=null) session.setAttribute("status",status);
        if (title!=null) session.setAttribute("title",title);
        if (swVersion!=null) session.setAttribute("swVersion",swVersion);
        switch (priority) {
            case 1:
                session.setAttribute("priority","Routine");
                break;
            case 2:
                session.setAttribute("priority","Urgent");
                break;
            case 3:
                session.setAttribute("priority","Critical");
                break;
            default:
                session.setAttribute("priority","Routine");
        }
        if (description!=null) session.setAttribute("description",description);
        if (changeRequired!=null) session.setAttribute("changeRequired",changeRequired);
        if (startDate!=null) session.setAttribute("startDate",startDate);
        if (endDate!=null) session.setAttribute("endDate",endDate);
        if (manpower!=null) session.setAttribute("manpower",manpower);
        if (environment!=null) session.setAttribute("environment",environment);
        if (responsibleStaff!=null) session.setAttribute("responsibleStaff",responsibleStaff);
        if (solution!=null) session.setAttribute("solution",solution);
        if (decision!=null) session.setAttribute("decision",decision);
        if (recipientAddr==null) recipientAddr = defaultRecipientAddress;
        if (recipientAddr!=null) session.setAttribute("recipientAddr",recipientAddr);
        if (ccAddr!=null) session.setAttribute("ccAddr",ccAddr);
        if (senderAddr==null) senderAddr = defaultSenderAddress;
        if (senderAddr!=null) session.setAttribute("senderAddr",senderAddr);
        if (haveError) session.setAttribute("haveError","true");
        else session.setAttribute("haveError","false");
        if (message!=null) session.setAttribute("message",message);
        for (int i=0; i<attachmentFields.size(); i++) {
            ByteArrayDataSource ds = (ByteArrayDataSource)attachmentFields.get(i);
            session.setAttribute("attachmentFile"+i,ds.getName()+" ("+ds.getLength()+" bytes)");
            if (ds.isSelected()) session.setAttribute("attachmentFileSel"+i,"on");
            else session.setAttribute("attachmentFileSel"+i,"off");
        }
        if (forwardToJsp!=null) session.setAttribute("ForwardJsp",forwardToJsp);
    }//setPageParameters

    private boolean parameterCheck()
    {
        haveError = false;
        message = "";
        if (originator.equals("")) {
            if (language==1) message += "Originator Obbligatorio<br> ";
            else message += "Please provide a value for 'Originator'<br> ";
            haveError = true;
        }
        if (title.equals("")) {
            if (language==1) message += "Nome del Prodotto Obbligatorio<br> ";
            else message += "Please provide a value for 'Software Item Title'<br> ";
            haveError = true;
        }
        if (problemType==1) {
            if (description.equals("")) {
                if (language==1) message += "Descrizione del Problema Obbligatorio<br> ";
                else message += "Please provide a value for 'Problem Description'<br> ";
                haveError = true;
            }
        }
        if (problemType==2) {
            if (changeRequired.equals("")) {
                if (language==1) message += "Descrizione del Cambio Requesto<br> ";
                else message += "Please provide a value for 'Change Required'<br> ";
                haveError = true;
            }
        }
        if (recipientAddr==null) {
            if (language==1) message += "Indirizzo e-mail del \"Software Review Boards\" Obbligatorio<br> ";
            else message += "Please provide a e-mail address for Software Review Boards<br> ";
            haveError = true;
        } else if (recipientAddr.equals("")) {
            if (language==1) message += "Indirizzo e-mail del \"Software Review Boards\" Obbligatorio<br> ";
            else message += "Please provide a e-mail address for Software Review Boards<br> ";
            haveError = true;
        }
        if (senderAddr==null) {
            if (language==1) message += "Indirizzo e-mail del Mittente Obbligatorio<br> ";
            else message += "Please provide a e-mail address for Originator<br> ";
            haveError = true;
        } else if (senderAddr.equals("")) {
            if (language==1) message += "Indirizzo e-mail del Mittente Obbligatorio<br> ";
            else message += "Please provide a e-mail address for Originator<br> ";
            haveError = true;
        }
        return !haveError;
    }//parameterCheck

    private void sendMessage()
    {
        Properties props = System.getProperties();
        Session session;
        MimeMessage messg;
        MimeMultipart multiPart;
        MimeBodyPart bodyPart;
        String msgBody = "";
        String xmlBody = "";

        doSend = false;
        haveError = false;
        isSend = false;
        try {
            if (smtpHost != null)
                props.put("mail.smtp.host", smtpHost);
            else if (props.getProperty("mail.smtp.host") == null)
                props.put("mail.smtp.host", InetAddress.getLocalHost().getHostName());
             props.put("mail.smtp.port", "25");
        } catch (java.net.UnknownHostException ex) {
            message = ex.toString();
            haveError = true;
            Log.log("ProblemReportMailer.sendMessage() Exception: "+ex);
            ex.printStackTrace(System.out);
            return;
        }
        
        session = Session.getDefaultInstance(props, null);
        messg = new MimeMessage(session);

        try {
            InternetAddress toAddrs[] = InternetAddress.parse(recipientAddr, false);
            messg.setRecipients(Message.RecipientType.TO, toAddrs);
            messg.setFrom(new InternetAddress(senderAddr));
            if (ccAddr != null) {
                InternetAddress ccAddrs[] = InternetAddress.parse(ccAddr, false);
                messg.setRecipients(Message.RecipientType.CC, ccAddrs);
            }

            if (subject==null) {
                if (problemType == 1) subject = "New Software Problem Report (SPR)";
                else if (problemType == 2) subject = "New Software Change Request (SCR)";
                else subject = "";
            }
            messg.setSubject(subject);

            if (problemType == 1) xmlBody += "<SoftwareProblemReport>\n";
            else if (problemType == 2) xmlBody += "<SoftwareChangeRequest>\n";
            if (date!=null) {
                xmlBody += "  <date>"+date+"</date>\n";
                msgBody += "Date: "+date+"\n";
            }
            if (originator!=null) {
                xmlBody += "  <originator>"+originator+"</originator>\n";
                msgBody += "Originator: "+originator+"\n";
            }
            if (status!=null) {
                xmlBody += "  <status>"+status+"</status>\n";
                msgBody += "Status: "+status+"\n";
            }
            if (title!=null) {
                xmlBody += "  <title>"+title+"</title>\n";
                msgBody += "Item Title: "+title+"\n";
            }
            if (swVersion!=null) {
                xmlBody += "  <swVersion>"+swVersion+"</swVersion>\n";
                msgBody += "Version/Release number: "+swVersion+"\n";
            }
            xmlBody += "  <priority>"+priority+"</priority>\n";
            msgBody += "Priority: ";
            switch (priority) {
                case 1:
                    msgBody += "Routine\n";
                    break;
                case 2:
                    msgBody += "Urgent\n";
                    break;
                case 3:
                    msgBody += "Critical\n";
                    break;
                default:
                    msgBody += "\n";
            }
            if (description!=null) {
                xmlBody += "  <description>\n"+description+"\n  </description>\n";
                msgBody += "Problem Description: \n"+description+"\n";
            }
            if (changeRequired!=null) {
                xmlBody += "  <change-required>\n"+changeRequired+"\n  </change-required>\n";
                msgBody += "Change Required: \n"+changeRequired+"\n";
            }
            if (environment!=null) {
                xmlBody += "  <environment>"+environment+"</environment>\n";
                msgBody += "Environment Description: \n"+environment+"\n";
            }
            if (responsibleStaff!=null) {
                xmlBody += "  <responsible-staff>"+responsibleStaff+"</responsible-staff>\n";
                msgBody += "Responsible Staff: \n"+responsibleStaff+"\n";
            }
            if (solution!=null) {
                xmlBody += "  <solution>\n"+solution+"\n  </solution>\n";
                msgBody += "Recommended Solution: \n"+solution+"\n";
            }
            if (decision!=null) {
                xmlBody += "  <decision>\n"+decision+"\n  </decision>\n";
                msgBody += "Software Review Board Decision: \n"+decision+"\n";
            }
            if (startDate!=null) {
                xmlBody += "  <start-date>"+startDate+"  </start-date>\n";
                msgBody += "Start Date: \n"+startDate+"\n";
            }
            if (endDate!=null) {
                xmlBody += "  <end-date>"+endDate+"  </end-date>\n";
                msgBody += "End Date: \n"+endDate+"\n";
            }
            if (manpower!=null) {
                xmlBody += "  <manpower>\n"+manpower+"\n  </manpower>\n";
                msgBody += "Manpower: \n"+manpower+"\n";
            }
            if (attachmentFields.size()>0) {
                xmlBody += "  <attachment>\n";
                for (int i=0; i<attachmentFields.size(); i++) {
                    ByteArrayDataSource ds = (ByteArrayDataSource)attachmentFields.get(i);
                    xmlBody += ds.getName()+", ";
                }
                xmlBody += "  </attachment>\n";
            }
            xmlBody += "  <senderAddr>"+senderAddr+"</senderAddr>\n";
            if (ccAddr!=null) xmlBody += "  <ccAddr>"+ccAddr+"</ccAddr>\n";
            if (problemType == 1) xmlBody += "</SoftwareProblemReport>\n";
            else if (problemType == 2) xmlBody += "</SoftwareChangeRequest>\n";

            bodyPart = new MimeBodyPart();
            bodyPart.setText(msgBody);
            multiPart = new MimeMultipart();
            multiPart.addBodyPart(bodyPart);

            bodyPart = new MimeBodyPart();
            bodyPart.setText(xmlBody);
//            bodyPart.setContent(xmlBody, "text/xml");
            if (problemType == 1) bodyPart.setFileName("spr.xml");
            else if (problemType == 2) bodyPart.setFileName("scr.xml");
            multiPart.addBodyPart(bodyPart);

            for (int i=0; i<attachmentFields.size(); i++) {
                ByteArrayDataSource ds = (ByteArrayDataSource)attachmentFields.get(i);
                if (ds.isSelected()) {
                    bodyPart = new MimeBodyPart();
                    bodyPart.setDataHandler(new DataHandler(ds));
                    bodyPart.setDisposition("attachment; filename=\""+ds.getName()+"\"");
                    bodyPart.setFileName(ds.getName());

                    multiPart.addBodyPart(bodyPart);
                }
            }
            messg.setContent(multiPart);

            Transport.send(messg);
        } catch (Exception ex) {
            message = ex.toString();
            haveError = true;
            Log.log("ProblemReportMailer.sendMessage() Exception: "+ex);
            ex.printStackTrace(System.out);
            return;
        }
        message = "Segnalazione Inviato!";
        Log.log("ProblemReportMailer.sendMessage(): Message send to "+recipientAddr);
        isSend = true;
    }//sendMessage
}//ReportMailerServlet
