/*
 * ConnectionHandler.java     Auther: Henrik Baastrup (c) 2003
 *
 * This software is licensed under the GNU LGPL (Lesser general Public License):
 *   http://www.gnu.org/copyleft/lesser.html
 *
 * Created on October 1, 2003, 4:35 PM
 */
package com.hbaastrup.AutoReportGenerator.dataLayer;
import javax.naming.*;
import javax.sql.*;
import java.sql.*;


public class ConnectionHandler
{
    static ConnectionHandler mySelfInstance = null;
    
    private ConnectionHandler()
    {
    }
    
    public static synchronized ConnectionHandler getInstance()
    {
        if (mySelfInstance==null) mySelfInstance = new ConnectionHandler();
        return mySelfInstance;
    }

//    public static Connection getStaticConnection() throws javax.naming.NamingException, java.sql.SQLException
    public static Connection getConnection() throws javax.naming.NamingException, java.sql.SQLException
    {
        DataSource dbDataSource = null;
        Connection conn;
        try {
            javax.naming.Context ctx = new InitialContext();
            if (ctx==null)  return null;
            dbDataSource = (DataSource) ctx.lookup("java:comp/env/jdbc/ArgDb");
            conn=dbDataSource.getConnection();
        } catch (javax.naming.NamingException ex) {
            throw ex;
        } catch (java.sql.SQLException ex) {
            throw ex;
        }
        return conn;
    }//getConnection
    
//    public static Connection getConnection() throws javax.naming.NamingException, java.sql.SQLException
    public static Connection getJdbcConnection() throws javax.naming.NamingException, java.sql.SQLException
    {
        Connection conn = null;
        try {
            Class.forName("com.mysql.jdbc.Driver");
//            conn = DriverManager.getConnection("jdbc:mysql://localhost:3306/AutoReportGenerator", "arguser", "password");
//            conn = DriverManager.getConnection("jdbc:mysql://itmos066.mo.it.eds.com:3306/AutoReportGenerator", "arguser", "password");
            conn = DriverManager.getConnection("jdbc:mysql://itmow222.mo.it.eds.com:3306/AutoReportGenerator", "arguser", "password");
        } catch (ClassNotFoundException ex) {
            ex.printStackTrace();
            return null;
        } catch (SQLException ex) {
            ex.printStackTrace();
            return null;
        }
        return conn;
    }//getJdbcConnection
    
}//ConnectionHandler
