/*
 * GenericLoginModule.java
 *
 * Created on December 19, 2003, 3:14 PM
 */

package com.hbaastrup.AutoReportGenerator.realm;

import java.util.*;
import com.hbaastrup.AutoReportGenerator.dataLayer.*;

public class GenericLoginModule implements javax.security.auth.spi.LoginModule
{
    private javax.security.auth.Subject subject = null;
    private javax.security.auth.callback.CallbackHandler callbackHandler = null;
    
    public GenericLoginModule()
    {
    }//GenericLoginModule
    
    public boolean abort() throws javax.security.auth.login.LoginException
    {
        return true;
    }
    
    public boolean commit() throws javax.security.auth.login.LoginException
    {
        return true;
    }
    
    public void initialize(javax.security.auth.Subject subject, javax.security.auth.callback.CallbackHandler callbackHandler, java.util.Map sharedState, java.util.Map options)
    {
        this.subject = subject;
        this.callbackHandler = callbackHandler;
    }
    
    public boolean login() throws javax.security.auth.login.LoginException
    {
        Users users = new Users();
        int projectId = 0;
        javax.security.auth.callback.Callback[] callback = new javax.security.auth.callback.Callback[3];
        if (callbackHandler==null) return false;
        javax.security.auth.callback.NameCallback nameCallback = new javax.security.auth.callback.NameCallback("Username:");
        javax.security.auth.callback.PasswordCallback passwordCallback = new javax.security.auth.callback.PasswordCallback("Password:",false);
        javax.security.auth.callback.TextInputCallback textInputCallback = new javax.security.auth.callback.TextInputCallback("Project id:");
        callback[0] = nameCallback;
        callback[1] = passwordCallback;
        callback[2] = textInputCallback;
        try {
            callbackHandler.handle(callback);
        } catch (Exception ex) {
            ex.printStackTrace();
            return false;
        }
        
        try {
            projectId = Integer.parseInt(textInputCallback.getText());
            if (users.findByPrimaryKey(projectId, nameCallback.getName())==null) return false;
        } catch (Exception ex) {
            ex.printStackTrace();
            return false;
        }
        if (!String.copyValueOf(passwordCallback.getPassword()).equals(users.getPassword())) return false;
        
        GenericPrincipal princ = new GenericPrincipal(users.getUserId(), users.getPassword(), users.getProjectId(), users.getRoles());
        Set subPrincipals = subject.getPrincipals();
        subPrincipals.add(princ);
        
        return true;
    }
    
    public boolean logout() throws javax.security.auth.login.LoginException
    {
        return true;
    }
}//GenericLoginModule
