/*
 * GenericPrincipal.java   Auther: Henrik Baastrup (c) 2003
 *
 * This software is licensed under the GNU LGPL (Lesser general Public License):
 *   http://www.gnu.org/copyleft/lesser.html
 *
 * Created on December 18, 2003, 7:31 PM
 */

package com.hbaastrup.AutoReportGenerator.realm;
import java.util.*;
import java.security.Principal;

public class GenericPrincipal implements Principal
{
    protected String name = null;
    protected String password = null;
    protected int projectId = 0;
    protected String roles[] = null; 
    
    public GenericPrincipal(String aName, String aPassword, int aProjectId)
    {
        this(aName, aPassword, aProjectId, null);
    }
    
    public GenericPrincipal(String aName, String aPassword, int aProjectId, List aRoles)
    {
        name = aName;
        password = aPassword;
        projectId = aProjectId;
        if (aRoles!=null) {
            roles = new String[aRoles.size()];
            roles = (String[])aRoles.toArray(roles);
            Arrays.sort(roles);
        }
        else roles = null;
    }//GenericPrincipal
    
    public String getName() {return name;}
    public String getPassword() {return password;}
    public int getProjectId() {return projectId;}
    public String[] getRouls() {return roles;}
}
