/*
 * JAASCallBackHandler.java   Auther: Henrik Baastrup (c) 2003
 *
 * This software is licensed under the GNU LGPL (Lesser general Public License):
 *   http://www.gnu.org/copyleft/lesser.html
 *
 * Created on December 18, 2003, 7:35 PM
 */

package com.hbaastrup.AutoReportGenerator.realm;
import javax.security.auth.callback.CallbackHandler;

public class JAASCallBackHandler implements CallbackHandler
{
    protected String userName = null;
    protected String password = null;
    protected int projectId = 0;
    
    JAASCallBackHandler(String aUserName, String aPassword, int aProjectId)
    {
        super();
        userName = aUserName;
        password = aPassword;
        projectId = aProjectId;
    }
    
    public void handle(javax.security.auth.callback.Callback[] callback) throws java.io.IOException, javax.security.auth.callback.UnsupportedCallbackException
    {
System.out.println("JAASCallBackHandler.handle()");
        for (int i=0; i< callback.length; i++) {
            if (callback[i] instanceof javax.security.auth.callback.NameCallback) {
                ((javax.security.auth.callback.NameCallback)callback[i]).setName(userName);
            }
            else if (callback[i] instanceof javax.security.auth.callback.PasswordCallback) {
                ((javax.security.auth.callback.PasswordCallback)callback[i]).setPassword(password.toCharArray());
            }
            else if (callback[i] instanceof javax.security.auth.callback.TextInputCallback) {
                ((javax.security.auth.callback.TextInputCallback)callback[i]).setText(Integer.toString(projectId));
            }
            else {
                throw new javax.security.auth.callback.UnsupportedCallbackException(callback[i]);
            }
        }
    }//handle
}//JAASCallBackHandler
