/*
 * Administration.java   Auther: Henrik Baastrup (c) 2003
 *
 * This software is licensed under the GNU LGPL (Lesser general Public License):
 *   http://www.gnu.org/copyleft/lesser.html
 *
 * Created on February 3, 2004, 11:15 AM
 */

package com.hbaastrup.AutoReportGenerator.servlets;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;
import com.hbaastrup.AutoReportGenerator.realm.*;
import com.hbaastrup.AutoReportGenerator.dataLayer.*;

public class Administration extends HttpServlet
{
    
    public Administration() {
    }//Administration
    
    protected void  service(HttpServletRequest request, HttpServletResponse response) throws javax.servlet.ServletException
    {
        String nextJspPage = "/jsp/blank.jsp";
        HttpSession session = request.getSession(false);
        SessionBinder sessionBinder = null;
        Vector tablePrintValues = new Vector(0);
        Users users = new Users();
        Projects projects = new Projects();
        Users user = new Users();
        SequenceKeys sequenceKey = new SequenceKeys();
        String action;
        String subAction;
        String userId = null;
        String projectId = null;
        String password = null;
        String initials = null;
        String eMail = null;
        String description = null;
        String title = null;
        String version = null;
        String roles[] = null;
        
        if (session==null) {
             javax.servlet.ServletException ex = new javax.servlet.ServletException("The HttpSession for the actual session is null");
             throw ex;
        }
        if ((sessionBinder=(SessionBinder)session.getAttribute("sessionBinder"))==null) {
             javax.servlet.ServletException ex = new  javax.servlet.ServletException("SessionBinder for the actual session is null");
             throw ex;
        }
        if (!sessionBinder.doesUserHasRoule("administrator")) {
             javax.servlet.ServletException ex = new  javax.servlet.ServletException("User has not administrator access rights");
             throw ex;
        }
        
System.out.println("Administration: projectId="+sessionBinder.getProjectId());
        // Get the parameters for this request
        if ((action=request.getParameter("action"))==null) action = "";
        if ((subAction=request.getParameter("subAction"))==null) subAction = "";
        if ("".equals(action)) action = subAction;
        userId=request.getParameter("userId");
        if ((projectId=request.getParameter("projectId"))==null) projectId="0";
        if ("".equals(projectId)) projectId = "0";
        password=request.getParameter("password");
        initials=request.getParameter("initials");
        eMail=request.getParameter("eMail");
        description=request.getParameter("description");
        title=request.getParameter("title");
        version=request.getParameter("version");
        roles = request.getParameterValues("roles");
        
System.out.println("Administration: action="+action);
        
        try {
            if (action.equals("Save")) {
                boolean createRec = false;
                if (subAction.equals("Users")) {
                    if (users.findByPrimaryKey(sessionBinder.getProjectId(), userId)==null) createRec = true;
                    users = new Users(sessionBinder.getProjectId(), userId);
                    users.setPassword(password);
                    users.setInitials(initials);
                    users.setEMail(eMail);
                    users.setDescription(description);
                    users.setRoles(roles);
                    if (createRec) users.create();
                    else users.store();
                    action = "Users";
                }
                else if (subAction.equals("Projects")) {
                    if (projects.findByPrimaryKey(Integer.parseInt(projectId))==0) {
                        int prId = sequenceKey.getNextSequence(0, "Projects");
                        projectId = Integer.toString(prId);
                        
                        user = new Users(prId, "admin");
                        user.setPassword("admin");
                        user.setInitials("Admin");
                        user.setRoles("administrator,user,viewer,reviewer");
                        user.setDescription("Default administrator");
                        user.create();
                        
                        sequenceKey = new SequenceKeys(prId,"Software_Problem_Report");
                        sequenceKey.create();
                        sequenceKey = new SequenceKeys(prId,"Software_Change_Request");
                        sequenceKey.create();
                        sequenceKey = new SequenceKeys(prId,"Software_Modification_Report");
                        sequenceKey.create();
                        createRec = true;
                    }
                    projects = new Projects(Integer.parseInt(projectId));
                    projects.setSwTitle(title);
                    projects.setSwVersion(version);
                    projects.setDescription(description);
                    if (createRec) {
                        projects.create();
                        request.setAttribute("errorInfo", "Project "+projectId+" was created with a default administrator: admin with password: admin");
                    }
                    else projects.store();
                    action = "Projects";
                }
            }
            else if (action.equals("Delete")) {
                if (subAction.equals("Users")) {
                    if (users.findByPrimaryKey(sessionBinder.getProjectId(), userId)!=null) {
                        users.remove();
                        request.setAttribute("errorInfo", "User "+userId+" was deleted");
                    }
                    userId = null;
                    action = "Users";
                }
                else if (subAction.equals("Projects")) {
System.out.println("Delete projectId="+projectId);
                    if (projects.findByPrimaryKey(Integer.parseInt(projectId))!=0) {
                        projects.remove();
                        user.removeByProjectId(Integer.parseInt(projectId));
                        sequenceKey.removeByProjectId(Integer.parseInt(projectId));
                        
                        SoftwareProblemReport spr = new SoftwareProblemReport();
                        spr.removeByProjectId(Integer.parseInt(projectId));
                        SoftwareChangeRequest scr = new SoftwareChangeRequest();
                        scr.removeByProjectId(Integer.parseInt(projectId));
                        SoftwareModificationReport smr = new SoftwareModificationReport();
                        smr.removeByProjectId(Integer.parseInt(projectId));
                        
                        request.setAttribute("errorInfo", "Project "+projectId+" was deleted");
                    }
                    projectId = null;
                    action = "Projects";
                }
            }
            else if (action.equals("Reset")) {
                if (subAction.equals("Users")) {
                    userId = null;
                    action = "Users";
                }
                else if (subAction.equals("Projects")) {
                    projectId = null;
                    action = "Projects";
                }
            }
            if (action.equals("Users")) {
                nextJspPage = "/jsp/users.jsp";
                if (userId!=null) {
                    if (users.findByPrimaryKey(sessionBinder.getProjectId(), userId)!=null) {
                        request.setAttribute("selected", users.getUserId());
                        tablePrintValues.addElement(users.getUserId());
                        tablePrintValues.addElement(users.getPassword());
                        tablePrintValues.addElement(users.getInitials());
                        tablePrintValues.addElement(users.getEMail());
                        tablePrintValues.addElement(users.getDescription());
                        if (sessionBinder.doesUserHasRoule("projects")) {
                            if (users.doesUserHasRoule("projects")) tablePrintValues.addElement("checked='checked'");
                            else tablePrintValues.addElement("");
                        }
                        if (users.doesUserHasRoule("administrator")) tablePrintValues.addElement("checked='checked'");
                        else tablePrintValues.addElement("");
                        if (users.doesUserHasRoule("user")) tablePrintValues.addElement("checked='checked'");
                        else tablePrintValues.addElement("");
                        if (users.doesUserHasRoule("viewer")) tablePrintValues.addElement("checked='checked'");
                        else tablePrintValues.addElement("");
                        if (users.doesUserHasRoule("reviewer")) tablePrintValues.addElement("checked='checked'");
                        else tablePrintValues.addElement("");
                    }
                    else request.setAttribute("errorInfo", "Not existing user: "+userId);
                }
                else {
                    tablePrintValues.addElement("");
                    tablePrintValues.addElement("");
                    tablePrintValues.addElement("");
                    tablePrintValues.addElement("");
                    tablePrintValues.addElement("");
                    tablePrintValues.addElement("");
                    tablePrintValues.addElement("");
                    tablePrintValues.addElement("");
                }
            }
            else if (action.equals("Projects")) {
                nextJspPage = "/jsp/projects.jsp";
                if (projectId!=null) {
                    if (projects.findByPrimaryKey(Integer.parseInt(projectId))!=0) {
                        request.setAttribute("selected", Integer.toString(projects.getProjectId()));
                        tablePrintValues.addElement(Integer.toString(projects.getProjectId()));
                        tablePrintValues.addElement(projects.getSwTitle());
                        tablePrintValues.addElement(projects.getSwVersion());
                        tablePrintValues.addElement(projects.getDescription());
                    }
                    else {
                        tablePrintValues.addElement("");
                        tablePrintValues.addElement("");
                        tablePrintValues.addElement("");
                        tablePrintValues.addElement("");
                    }
                }
                else {
                    tablePrintValues.addElement("");
                    tablePrintValues.addElement("");
                    tablePrintValues.addElement("");
                    tablePrintValues.addElement("");
                }
            }
        } catch (Exception ex) {
            request.setAttribute("errorInfo", ex.toString());
            nextJspPage = "/jsp/blank.jsp";
            ex.printStackTrace();
        }
        
System.out.println("Administration Next page: "+nextJspPage);
        request.setAttribute("tablePrintValues", tablePrintValues);
        request.setAttribute("findByParam", Integer.toString(sessionBinder.getProjectId()));
        response.setDateHeader("Last-modified", System.currentTimeMillis());
        try {
            request.getRequestDispatcher(nextJspPage).forward(request, response);
        } catch (javax.servlet.ServletException ex) {
            throw ex;
        } catch (java.io.IOException ex) {
            throw new javax.servlet.ServletException(ex);
        }
    }//service
}//Administration
