/*
 * Attachment.java      Auther: Henrik Baastrup (c) 2003
 *
 * This software is licensed under the GNU LGPL (Lesser general Public License):
 *   http://www.gnu.org/copyleft/lesser.html
 *
 * Created on January 20, 2004, 3:45 PM
 */

package com.hbaastrup.AutoReportGenerator.servlets;
import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;
import com.hbaastrup.AutoReportGenerator.utils.*;

public class Attachment extends HttpServlet
{
//    public static final int MAX_ATTACHMENT_SIZE = 65536; //64K bytes (2 bytes BLOB)
    public static final long MAX_ATTACHMENT_SIZE = 16777216; //16M bytes (3bytes MEDIUMBLOB)
//    public static final long MAX_ATTACHMENT_SIZE = 4294967296; //4G bytes (4bytes LAGEBLOB)
    
    private Vector parameterFields = new Vector(0);
    private ReportAttributes reportAttributes = null;
    private String toBigAttacment = null;
    
    /** Creates a new instance of Attachment */
    public Attachment() {
    }
    
    protected void  service(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException
    {
        String nextJspPage = "/jsp/blank.jsp";
        java.io.PrintWriter out;
        String action = null;
        int toBigAttacmentInx = 0;
        String str;
        HttpSession session = request.getSession(false);
        
        ResourceBundle localStrings = (ResourceBundle)session.getAttribute("localStrings");
        
        reportAttributes = (ReportAttributes)session.getAttribute("reportAttributes");
if (reportAttributes==null) System.out.println("reportAttributes=null");
else System.out.println("reportAttributes is validated");
        if (reportAttributes==null) reportAttributes = new ReportAttributes();
        
System.out.println("Attachment method="+request.getMethod());
        if (request.getMethod().equals("POST")) {
            if (reportAttributes==null) reportAttributes = new ReportAttributes();
            doUpload(request, response);
            Enumeration parameters = parameterFields.elements();
System.out.println("Attachment Parameters:");
            while (parameters.hasMoreElements()) {
                ParameterField pf = (ParameterField)parameters.nextElement();
                if (pf.name.equals("action")) action = pf.value;
                else if (pf.name.startsWith("attachmentFileSel")) {
                    int inx = Integer.parseInt(pf.name.substring(17));
                    ByteArrayDataSource ds = (ByteArrayDataSource)reportAttributes.attachments.get(inx);
                    if (pf.value.equals("on")) ds.setSelected(true);
                    else ds.setSelected(false);
                }
System.out.println("  name="+pf.name+"  value=<"+pf.value+">");
            }
        }
        if (action==null && (action=request.getParameter("action"))==null) action = "";
        
        toBigAttacment = null;
        for (int i=0; i<reportAttributes.attachments.size(); i++) {
            ByteArrayDataSource ds = (ByteArrayDataSource)reportAttributes.attachments.get(i);
            if (ds.getLength() > MAX_ATTACHMENT_SIZE) {
                toBigAttacment = "The file "+ds.getName()+" ("+ds.getLength()+" bytes) is to big. Max. size is "+MAX_ATTACHMENT_SIZE+" bytes";
                toBigAttacmentInx = i;
            }
            if (!ds.isTuched()) ds.setSelected(false);
            ds.unTuch();
        }
        if (toBigAttacment!=null) reportAttributes.attachments.remove(toBigAttacmentInx);
        
System.out.println("Attachment action="+action);
        try {
            out = response.getWriter();
            
            if (action.equals(localStrings.getString("cancel"))) {
            }
            else if (action.equals(localStrings.getString("attach")+"!")) {
            }
            else if (action.equals(localStrings.getString("attachFiles")) || action.equals(localStrings.getString("add"))) {
                response.setContentType("text/html");
                attachFiles(out, localStrings);
                return;
            }
        } catch (Exception ex) {
            request.setAttribute("errorInfo", ex.toString());
            nextJspPage = "/jsp/blank.jsp";
            ex.printStackTrace();
        }
        
//        request.setAttribute("reportAttributes", reportAttributes);
        if (reportAttributes!=null) switch (reportAttributes.repType) {
             case ReportGenerator.SPR_REPORT_TYPE:
                 nextJspPage = "/SPR";
                 break;
             case ReportGenerator.SCR_REPORT_TYPE:
                 nextJspPage = "/SCR";
                 break;
             case ReportGenerator.SMR_REPORT_TYPE:
                 nextJspPage = "/SMR";
                 break;
        }
        nextJspPage += "?action=FromAttachment";
System.out.println("nextJspPage="+nextJspPage);
        try {
            request.getRequestDispatcher(nextJspPage).forward(request, response);
        } catch (javax.servlet.ServletException ex) {
            throw ex;
        } catch (java.io.IOException ex) {
            throw new javax.servlet.ServletException(ex);
        }
    }//service
    
    
    private void attachFiles(java.io.PrintWriter out, ResourceBundle localStrings)
    {

            out.println("<html>");
            out.println("<head>");
            out.println("</head>");
            if (toBigAttacment!=null) out.println("<body background='jsp/images/PaperTexture.gif' onload='alert(\""+toBigAttacment+"\")'>");
            else out.println("<body background='jsp/images/PaperTexture.gif'>");
            out.println("<h1>"+localStrings.getString("attachFiles")+"</h1><br>");
//            out.println("<form method='post' enctype='multipart/form-data'>");
            out.println("<form method='post' enctype='multipart/form-data' action='Attachment'>");
            out.println("");
            out.println(localStrings.getString("lookForFileIn")+": <input type='file' name='attachment' size='50'>");
            out.println("<input type='submit' name='action' value='"+localStrings.getString("add")+"'><br>");
            out.println(localStrings.getString("toAttachFiles")+", <b>"+localStrings.getString("clickHere")+":</b> <input type='submit' name='action' value='"+localStrings.getString("attach")+"!'><br>");
            out.println("<input type='submit' name='action' value='"+localStrings.getString("cancel")+"'><br>");
            out.println(localStrings.getString("attachments")+":<br>");
            for (int i=0; i<reportAttributes.attachments.size(); i++) {
                ByteArrayDataSource ds = (ByteArrayDataSource)reportAttributes.attachments.get(i);
                if (ds.isSelected()) {
                    out.println(" <input type=checkbox name='attachmentFileSel"+i+"' checked>"+ds.getName()+" ("+ds.getLength()+" bytes)<br>");
                }
                else {
                    out.println(" <input type=checkbox name='attachmentFileSel"+i+"'>"+ds.getName()+" ("+ds.getLength()+" bytes)<br>");
                }
            }
            out.println("</form>");
            out.println("</body>");
            out.println("</html>");
    }//attachFiles

    private void doUpload(HttpServletRequest request, HttpServletResponse response)
    throws IOException
    {
        String boundary = request.getHeader("Content-Type");
        int pos = boundary.indexOf('=');
        boundary = boundary.substring(pos + 1);
        boundary = "--" + boundary;

        ServletInputStream in = request.getInputStream();
        byte[] bytes = new byte[512];
        int state = 0;
        ByteArrayOutputStream buffer = new ByteArrayOutputStream();
        String name = null,
               value = null,
               filename = null,
               contentType = null;

        parameterFields = new Vector(0);
        int nBytes = in.readLine(bytes,0,512);
        while(-1!=nBytes) {
            String st = new String(bytes,0,nBytes);
            if(st.startsWith(boundary)) {
                state = 0;
                if(null != name) {
                    if(value != null) {
                        ParameterField pf = new ParameterField();
                        pf.name = name;
                        pf.value = new String(value.getBytes(),0,value.length()-2);// -2 to remove CR/LF
                        parameterFields.add(pf);// -2 to remove CR/LF
                    }
                    else if(buffer.size() > 2) {
                        ByteArrayDataSource ds = new ByteArrayDataSource(buffer.toByteArray(), contentType, filename);
                        reportAttributes.attachments.add(ds);
                    }
                    name = null;
                    value = null;
                    filename = null;
                    contentType = null;
                    buffer = new ByteArrayOutputStream();
                }
            }
            else if(st.startsWith("Content-Disposition: form-data") && state == 0)  {
                StringTokenizer tokenizer = new StringTokenizer(st,";=\"");
                while(tokenizer.hasMoreTokens()) {
                    String token = tokenizer.nextToken();
                    if(token.startsWith(" name")) {
                        name = tokenizer.nextToken();
                        state = 2;
                    }
                    else if(token.startsWith(" filename")) {
                        filename = tokenizer.nextToken();
                        StringTokenizer ftokenizer = new StringTokenizer(filename,"\\/:");
                        filename = ftokenizer.nextToken();
                        while(ftokenizer.hasMoreTokens()) filename = ftokenizer.nextToken();
                        state = 1;
                        break;
                    }
                }
            }
            else if(st.startsWith("Content-Type") && state == 1) {
                pos = st.indexOf(":");
                // + 2 to remove the space
                // - 2 to remove CR/LF
                contentType = st.substring(pos + 2,st.length() - 2);
            }
            else if(st.equals("\r\n") && state == 1) state = 3;
            else if(st.equals("\r\n") && state == 2) state = 4;
            else if(state == 4) value = value == null ? st : value + st;
            else if(state == 3) buffer.write(bytes,0,nBytes);

            nBytes = in.readLine(bytes,0,512);
        }
    }//doUpload
    
}
