/*
 * Login.java   Auther: Henrik Baastrup (c) 2003
 *
 * This software is licensed under the GNU LGPL (Lesser general Public License):
 *   http://www.gnu.org/copyleft/lesser.html
 *
 *
 * Created on December 18, 2003, 4:02 PM
 */

package com.hbaastrup.AutoReportGenerator.servlets;
import java.util.*;
import javax.servlet.http.*;
import com.hbaastrup.AutoReportGenerator.realm.*;

public class Login extends HttpServlet
{
    public Login()
    {
        Properties prop = System.getProperties();
        prop.setProperty("java.security.auth.login.config", "/home/hbaastrup/projects/AutoReportGenerator/WEB-INF/deploy/login.config");
    }

    protected void  service(HttpServletRequest request, HttpServletResponse response) throws javax.servlet.ServletException
    {
        SessionBinder sessionBinder = null;
        String userId, password, str;
        int projectId = 0;
        String nextJspPage = "/jsp/main.jsp";
        
        //Internationalization stuff
        Locale currentLocale;
        if ((currentLocale=request.getLocale())==null) currentLocale = new Locale("en");
System.out.println("Login: Requested locale contry="+currentLocale.getDisplayCountry()+" locale language="+currentLocale.getDisplayLanguage());
        ResourceBundle localStrings = null;
        try {
                localStrings = ResourceBundle.getBundle("LocalStrings", currentLocale);
        } catch (MissingResourceException ex) {
            ex.printStackTrace();
        }
        
        userId = request.getParameter("userId");
        password = request.getParameter("password");
        if ((str=request.getParameter("projectId"))!=null) {
            if ("".equals(str)) projectId = 0;
            else projectId = Integer.parseInt(str);
        }
        
        HttpSession oldSession = request.getSession(false);
        if (oldSession!=null) {
            oldSession.setAttribute("sessionBinder", null);
            oldSession.invalidate();
        }
        HttpSession session = request.getSession();
        
        sessionBinder = (SessionBinder)session.getAttribute("sessionBinder");
        if (sessionBinder==null) {
System.out.println("Login: sessionBinder=null. Create a new!");
            sessionBinder = new SessionBinder();
            session.setAttribute("sessionBinder", sessionBinder);
            session.setAttribute("localStrings", localStrings);
        }
        
        if (userId!=null && !"".equals(userId)) {
System.out.println("Login: we are going to do authentication");
            if (!sessionBinder.authenticate(userId, password, projectId)) nextJspPage = "/jsp/login.jsp";
        }
        else nextJspPage = "/jsp/login.jsp";
        
if (session.getAttribute("sessionBinder")==null) System.out.println("session.sessionBinder=null!!!!!!!!!!!!!!");
        response.setDateHeader("Last-modified", System.currentTimeMillis());
        try {
            request.getRequestDispatcher(nextJspPage).forward(request, response);
        } catch (javax.servlet.ServletException ex) {
            throw ex;
        } catch (java.io.IOException ex) {
            throw new javax.servlet.ServletException(ex);
        }
    }//service
    
}//Login
