/*
 * Mailer.java
 *
 * Created on January 23, 2004, 12:51 PM
 */

package com.hbaastrup.AutoReportGenerator.servlets;
import java.util.*;
import javax.servlet.http.*;
import java.net.InetAddress;
import javax.mail.*;
import javax.mail.internet.*;
import com.hbaastrup.AutoReportGenerator.utils.*;
import com.hbaastrup.AutoReportGenerator.dataLayer.*;

/**
 *
 * @author  hbaastrup
 */
public class Mailer  extends HttpServlet
{
    private String smtpHost = null;
    private String subject = "";
    private String comment = "";
    private String resultMessage = "";
    private boolean inError = false;
    private boolean isSendBool = false;

    public Mailer()
    {
    }//Mailer
    
    public void init(javax.servlet.ServletConfig config) throws javax.servlet.ServletException
    {
        super.init(config);
        
        smtpHost = config.getInitParameter("SmtpHost");
    }//init
    
    protected void  service(HttpServletRequest request, HttpServletResponse response) throws javax.servlet.ServletException
    {
        String nextJspPage = "/jsp/blank.jsp";
        ReportAttributes reportAttributes = null;
        HttpSession session = request.getSession(false);
        Vector tablePrintValues = new Vector(0);
        String toAddr = null;
        String ccAddr = null;
        String fromAddr = null;
        String action = "";
        String reportTitle = "";
        
        ResourceBundle localStrings = (ResourceBundle)session.getAttribute("localStrings");
        if ((reportAttributes=(ReportAttributes)session.getAttribute("reportAttributes"))==null) {
            request.setAttribute("errorInfo", "There was no report attached!!!");
            nextJspPage = "/jsp/blank.jsp";
            try {
                request.getRequestDispatcher(nextJspPage).forward(request, response);
            } catch (javax.servlet.ServletException ex) {
                throw ex;
            } catch (java.io.IOException ex) {
                throw new javax.servlet.ServletException(ex);
            }
            return;
        }
        
        toAddr = request.getParameter("toAddr");
        ccAddr = request.getParameter("ccAddr");
        if ((fromAddr=request.getParameter("fromAddr"))==null) {
            if ((fromAddr=(String)request.getAttribute("fromAddr"))==null) fromAddr = "";
        }
        subject = request.getParameter("subject");
        comment = request.getParameter("comment");
        if ((action=request.getParameter("action"))==null) action = "";
        
        switch (reportAttributes.repType) {
            case ReportGenerator.NULL_REPORT_TYPE:
                reportTitle = "";
                break;
            case ReportGenerator.SPR_REPORT_TYPE:
                reportTitle = localStrings.getString("sprNo")+": "+reportAttributes.repNo+" "+reportAttributes.title;
                break;
            case ReportGenerator.SCR_REPORT_TYPE:
                reportTitle = localStrings.getString("scrNo")+": "+reportAttributes.repNo+" "+reportAttributes.title;
                break;
            case ReportGenerator.SMR_REPORT_TYPE:
                reportTitle = localStrings.getString("smrNo")+": "+reportAttributes.repNo+" "+reportAttributes.title;
                break;
        }
        if (subject==null || "".equals(subject)) subject = reportTitle;
        
        tablePrintValues.add(reportTitle);
        tablePrintValues.add(fromAddr);
        tablePrintValues.add(subject);
        try {
            if (action.equals("Send")) {
                if (fromAddr==null) fromAddr = "";
                if (toAddr==null || "".equals(toAddr)) {
                    request.setAttribute("errorInfo", "You have to provide a To address!");
                }
                else {
                    sendMessage(toAddr, ccAddr, fromAddr, reportAttributes);
                    if (resultMessage!=null && !"".equals(resultMessage)) request.setAttribute("errorInfo", resultMessage);
                }
            }
            else if (action.equals("Exit")) {
                nextJspPage = "/jsp/blank.jsp";
            }
            else {
                nextJspPage = "/jsp/mailer.jsp";
            }
        } catch (Exception ex) {
            request.setAttribute("errorInfo", ex.toString());
            nextJspPage = "/jsp/blank.jsp";
            ex.printStackTrace();
        }
        
        try {
            request.setAttribute("tablePrintValues", tablePrintValues);
            request.getRequestDispatcher(nextJspPage).forward(request, response);
        } catch (javax.servlet.ServletException ex) {
            throw ex;
        } catch (java.io.IOException ex) {
            throw new javax.servlet.ServletException(ex);
        }
    }//service


    private void sendMessage(String recipientAddr, String ccAddr, String fromAddr, ReportAttributes reportAttributes) throws javax.servlet.ServletException
    {
        Properties props = System.getProperties();
        javax.mail.Session session;
        MimeMessage messg;
        MimeMultipart multiPart;
        MimeBodyPart bodyPart;
        StringBuffer msgBody = new StringBuffer();
        StringBuffer xmlBody = new StringBuffer();

        inError = false;
        isSendBool = false;
        try {
            if (smtpHost != null)
                props.put("mail.smtp.host", smtpHost);
            else if (props.getProperty("mail.smtp.host") == null)
                props.put("mail.smtp.host", InetAddress.getLocalHost().getHostName());
            props.put("mail.smtp.port", "25");
        } catch (java.net.UnknownHostException ex) {
            throw(new javax.servlet.ServletException(ex.toString()));
        }
        
        session = javax.mail.Session.getDefaultInstance(props, null);
        messg = new MimeMessage(session);

        try {
            InternetAddress toAddrs[] = InternetAddress.parse(recipientAddr, false);
            messg.setRecipients(Message.RecipientType.TO, toAddrs);
            messg.setFrom(new InternetAddress(fromAddr));
            if (ccAddr != null) {
                InternetAddress ccAddrs[] = InternetAddress.parse(ccAddr, false);
                messg.setRecipients(Message.RecipientType.CC, ccAddrs);
            }

            if (subject==null) {
                if (reportAttributes.repType==ReportGenerator.SPR_REPORT_TYPE) subject = "New Software Problem Report (SPR)";
                else if (reportAttributes.repType==ReportGenerator.SCR_REPORT_TYPE) subject = "New Software Change Request (SCR)";
                else if (reportAttributes.repType==ReportGenerator.SMR_REPORT_TYPE) subject = "New Software Modification Report (SMR)";
                else subject = "";
            }
            messg.setSubject(subject);

            if (comment!=null) {
                msgBody = msgBody.append(comment + "\r\n\r\n");
            }
            
            if (reportAttributes.repType==ReportGenerator.SPR_REPORT_TYPE) xmlBody.append("<SoftwareProblemReport>\n");
            else if (reportAttributes.repType==ReportGenerator.SCR_REPORT_TYPE) xmlBody.append("<SoftwareChangeRequest>\n");
            else if (reportAttributes.repType==ReportGenerator.SMR_REPORT_TYPE) xmlBody.append("<SoftwareModificationReport>\n");
            if (reportAttributes.repNo!=0) {
                xmlBody.append("  <rep-no>"+reportAttributes.repNo+"</rep-no>\n");
                msgBody.append("Report number: "+reportAttributes.repNo+"\r\n");
            }
            if (reportAttributes.date!=null) {
                xmlBody.append("  <date>"+reportAttributes.date+"</date>\n");
                msgBody.append("Date: "+reportAttributes.date+"\r\n");
            }
            if (reportAttributes.originator!=null) {
                xmlBody.append("  <originator>"+reportAttributes.originator+"</originator>\n");
                msgBody.append("Originator: "+reportAttributes.originator+"\r\n");
            }
            if (reportAttributes.state==ReportGenerator.OPEN_STATE) {
                xmlBody.append("  <status>"+reportAttributes.state+"</status>\n");
                msgBody.append("Status: Open\r\n");
            }
            else {
                xmlBody.append("  <status>"+reportAttributes.state+"</status>\n");
                msgBody.append("Status: Close\r\n");
            }
            if (reportAttributes.scrNo!=0) {
                xmlBody.append("  <scr-no>"+reportAttributes.scrNo+"</scr-no>\n");
                msgBody.append("Software Change Request number: "+reportAttributes.scrNo+"\r\n");
            }
            if (reportAttributes.smrNo!=0) {
                xmlBody.append("  <smr-no>"+reportAttributes.smrNo+"</smr-no>\n");
                msgBody.append("Software Modification Report number: "+reportAttributes.smrNo+"\r\n");
            }
            if (reportAttributes.title!=null) {
                xmlBody.append("  <title>"+reportAttributes.title+"</title>\n");
                msgBody.append("\r\nItem Title: "+reportAttributes.title+"\r\n");
            }
            if (reportAttributes.swVersion!=null) {
                xmlBody.append("  <sw-version>"+reportAttributes.swVersion+"</sw-version>\n");
                msgBody.append("\r\nItem Version/Release number: "+reportAttributes.swVersion+"\r\n");
            }
            if (reportAttributes.priority!=ReportGenerator.NO_PRI) {
                xmlBody.append("  <priority>"+reportAttributes.priority+"</priority>\n");
                msgBody.append("\r\nPriority: ");

                switch (reportAttributes.priority) {
                    case ReportGenerator.ROUTINE_PRI:
                        msgBody.append("Routine\r\n");
                        break;
                    case ReportGenerator.URGENT_PRI:
                        msgBody.append("Urgent\r\n");
                        break;
                    case ReportGenerator.CRITICAL_PRI:
                        msgBody.append("Critical\r\n");
                        break;
                    default:
                        msgBody.append("\r\n");
                }
            }
            if (reportAttributes.description!=null && !"".equals(reportAttributes.description)) {
                xmlBody.append("  <description>\n"+reportAttributes.description+"\n  </description>\n");
                msgBody.append("\r\nProblem Description: \r\n"+reportAttributes.description+"\r\n");
            }
            if (reportAttributes.changeRequired!=null && !"".equals(reportAttributes.changeRequired)) {
                xmlBody.append("  <change-required>\n"+reportAttributes.changeRequired+"\n  </change-required>\n");
                msgBody.append("\r\nChange Required: \r\n"+reportAttributes.changeRequired+"\r\n");
            }
            if (reportAttributes.changeImplemented!=null && !"".equals(reportAttributes.changeImplemented)) {
                xmlBody.append("  <change-implemented>\n"+reportAttributes.changeImplemented+"\n  </change-implemented>\n");
                msgBody.append("\r\nChange Implemented: \r\n"+reportAttributes.changeImplemented+"\r\n");
            }
            if (reportAttributes.environment!=null && !"".equals(reportAttributes.environment)) {
                xmlBody.append("  <environment>"+reportAttributes.environment+"</environment>\n");
                msgBody.append("\r\nDescription of Environment: \r\n"+reportAttributes.environment+"\r\n");
            }
            if (reportAttributes.responsibleStaff!=null && !"".equals(reportAttributes.responsibleStaff)) {
                xmlBody.append("  <responsible-staff>"+reportAttributes.responsibleStaff+"</responsible-staff>\n");
                msgBody.append("\r\nResponisible Staf: \r\n"+reportAttributes.responsibleStaff+"\r\n");
            }
            if (reportAttributes.solution!=null && !"".equals(reportAttributes.solution)) {
                xmlBody.append("  <solution>\n"+reportAttributes.solution+"\n  </solution>\n");
                msgBody.append("\r\nRecommended Solution: \r\n"+reportAttributes.solution+"\n");
            }
            if (reportAttributes.decision!=null && !"".equals(reportAttributes.decision)) {
                xmlBody.append("  <decision>\n"+reportAttributes.decision+"\n  </decision>\n");
                msgBody.append("\r\nSoftware Review Board Decision: \r\n"+reportAttributes.decision+"\n");
            }
            if (reportAttributes.startDate!=null && !"".equals(reportAttributes.startDate)) {
                xmlBody.append("  <start-date>"+reportAttributes.startDate+"  </start-date>\n");
                msgBody.append("\r\nStart Date: "+reportAttributes.startDate+"\r\n");
            }
            if (reportAttributes.endDate!=null && !"".equals(reportAttributes.endDate)) {
                xmlBody.append("  <end-date>"+reportAttributes.endDate+" </end-date>\n");
                msgBody.append("End Date: "+reportAttributes.endDate+"\r\n");
            }
            if (reportAttributes.manpower!=null && !"".equals(reportAttributes.manpower)) {
                xmlBody.append("  <manpower>\n"+reportAttributes.manpower+"\n  </manpower>\n");
                msgBody.append("Manpower: "+reportAttributes.manpower+"\r\n");
            }
            if (reportAttributes.attachments.size()>0) {
                xmlBody.append("  <attachment>\n");
                for (int i=0; i<reportAttributes.attachments.size(); i++) {
                    ByteArrayDataSource ds = (ByteArrayDataSource)reportAttributes.attachments.get(i);
                    xmlBody.append(ds.getName()+", ");
                }
                xmlBody.append("  </attachment>\n");
            }
            if (reportAttributes.repType==ReportGenerator.SPR_REPORT_TYPE) xmlBody.append("<SoftwareProblemReport>\n");
            else if (reportAttributes.repType==ReportGenerator.SCR_REPORT_TYPE) xmlBody.append("<SoftwareChangeRequest>\n");
            else if (reportAttributes.repType==ReportGenerator.SMR_REPORT_TYPE) xmlBody.append("<SoftwareModificationReport>\n");

            msgBody.append("\r\nThis e-mail was created by the Auto Report Generator http://digilander.libero.it/hba/Linux/index.html\r\n");
            bodyPart = new MimeBodyPart();
            bodyPart.setText(msgBody.toString());
            multiPart = new MimeMultipart();
            multiPart.addBodyPart(bodyPart);

            bodyPart = new MimeBodyPart();
            bodyPart.setText(xmlBody.toString());
//            bodyPart.setContent(xmlBody, "text/xml");
            if (reportAttributes.repType==ReportGenerator.SPR_REPORT_TYPE) bodyPart.setFileName("spr.xml");
            else if (reportAttributes.repType==ReportGenerator.SCR_REPORT_TYPE) bodyPart.setFileName("scr.xml");
            else if (reportAttributes.repType==ReportGenerator.SMR_REPORT_TYPE) bodyPart.setFileName("smr.xml");
            multiPart.addBodyPart(bodyPart);

            for (int i=0; i<reportAttributes.attachments.size(); i++) {
                ByteArrayDataSource ds = (ByteArrayDataSource)reportAttributes.attachments.get(i);
                if (ds.isSelected()) {
                    bodyPart = new MimeBodyPart();
                    bodyPart.setDataHandler(new javax.activation.DataHandler(ds));
                    bodyPart.setDisposition("attachment; filename=\""+ds.getName()+"\"");
                    bodyPart.setFileName(ds.getName());

                    multiPart.addBodyPart(bodyPart);
                }
            }
            messg.setContent(multiPart);

            Transport.send(messg);
        } catch (Exception ex) {
            resultMessage = ex.toString();
            inError = true;
            Log.log("Mailer.sendMessage() Exception: "+ex);
            ex.printStackTrace(System.out);
            return;
        }
//        resultMessage = "Segnalazione Inviato!";
        resultMessage = "Message was send!";
        Log.log("Mailer.sendMessage(): Message send to "+recipientAddr);
        isSendBool = true;
    }//sendMessage
    
    public void setSmtpHost(String aHost) {smtpHost = aHost;}
    public void setSubject(String aSubject) {subject = aSubject;}
    public void setComment(String aComment) {comment = aComment;}
    
    public String getResultMessage() {return resultMessage;}
    public boolean getInError() {return inError;}
    public boolean isInError() {return inError;}
    public boolean getSend() {return isSendBool;}
    public boolean isSend() {return isSendBool;}
}//Mailer
