/*
 * ReportAssigner.java      Auther: Henrik Baastrup (c) 2003
 *
 * This software is licensed under the GNU LGPL (Lesser general Public License):
 *   http://www.gnu.org/copyleft/lesser.html
 *
 * Created on January 14, 2004, 9:38 AM
 */

package com.hbaastrup.AutoReportGenerator.servlets;
import java.util.*;
import javax.servlet.http.*;
import com.hbaastrup.AutoReportGenerator.realm.*;
import com.hbaastrup.AutoReportGenerator.dataLayer.*;

public class ReportAssigner extends HttpServlet
{
    java.text.SimpleDateFormat dateFormat = new java.text.SimpleDateFormat("dd/MM/yyyy");
    
    public ReportAssigner() {
    }
    
    protected void service(HttpServletRequest request, HttpServletResponse response) throws javax.servlet.ServletException
    {
        String nextJspPage = "/jsp/blank.jsp";
        HttpSession session = request.getSession(false);
        SessionBinder sessionBinder = null;
        SoftwareProblemReport softwareProblemReport = new SoftwareProblemReport();
        SoftwareChangeRequest softwareChangeRequest = new SoftwareChangeRequest();
        SoftwareModificationReport softwareModificationReport = new SoftwareModificationReport();
        Vector tableTdValues = new Vector(0);
        int projectId = 0;
        int repNo = 0;
        int sprNo = 0;
        int scrNo = 0;
        int repType = 0;
        String action;
        String str;

        if (session==null) {
             javax.servlet.ServletException ex = new  javax.servlet.ServletException("The HttpSession for the actual session is null");
             throw ex;
        }
        if ((sessionBinder=(SessionBinder)session.getAttribute("sessionBinder"))==null) {
             javax.servlet.ServletException ex = new  javax.servlet.ServletException("SessionBinder for the actual session is null");
             throw ex;
        }
        
        // Get the parameters for this request
        projectId = sessionBinder.getProjectId();
        if ((str=request.getParameter("repNo"))!=null) {
            if ("".equals(str) || "Not applyed".equals(str)) repNo = 0;
            else repNo = Integer.parseInt(str);
        }
        else repNo = 0;
        if ((str=request.getParameter("sprNo"))!=null) {
            if ("".equals(str) || "Not applyed".equals(str)) sprNo = 0;
            else sprNo = Integer.parseInt(str);
        }
        else sprNo = 0;
        if ((str=request.getParameter("scrNo"))!=null) {
            if ("".equals(str) || "Not applyed".equals(str)) scrNo = 0;
            else scrNo = Integer.parseInt(str);
        }
        else scrNo = 0;
        if ((str=request.getParameter("repType"))!=null) {
            if ("".equals(str)) repType = ReportGenerator.NULL_REPORT_TYPE;
            else repType = Integer.parseInt(str);
        }
        else repType = ReportGenerator.NULL_REPORT_TYPE;
        if ((action=request.getParameter("action"))==null) action = "";
        
        try {
            // Lets have some action
            if (action.equals("List")) {
                Collection coll;
                String buttonStr;
                switch (repType) {
                    case ReportGenerator.SPR_REPORT_TYPE:
                        if ((coll=softwareChangeRequest.findByProjectId(projectId))!=null) {
                            Iterator iter = coll.iterator();
                            while (iter.hasNext()) {
                                softwareChangeRequest = (SoftwareChangeRequest)iter.next();
                                tableTdValues.add("RepAssign");
                                tableTdValues.add(Integer.toString(repType));
                                tableTdValues.add(Integer.toString(softwareChangeRequest.getScrNo()));
                                tableTdValues.add(Integer.toString(softwareChangeRequest.getScrNo()));
                                tableTdValues.add(dateFormat.format(softwareChangeRequest.getDate()));
                                tableTdValues.add(softwareChangeRequest.getSwTitle());
                                tableTdValues.add("");
                                if (sessionBinder.doesUserHasRoule("user")) {
                                   buttonStr = "<input type=hidden value='"+repType+"' name='repType'><input type=hidden value='"+repNo+"' name='sprNo'><input type=submit value='Assign' name='action'>";
                                   tableTdValues.add(buttonStr);
                                }
                                else tableTdValues.add("&nbsp;");
                            }
                        }
                        nextJspPage = "/jsp/scrList.jsp";
                        break;
                    case ReportGenerator.SCR_REPORT_TYPE:
                        if ((coll=softwareModificationReport.findByProjectId(projectId))!=null) {
                            Iterator iter = coll.iterator();
                            while (iter.hasNext()) {
                                softwareModificationReport = (SoftwareModificationReport)iter.next();
                                tableTdValues.add("RepAssign");
                                tableTdValues.add(Integer.toString(repType));
                                tableTdValues.add(Integer.toString(softwareModificationReport.getSmrNo()));
                                tableTdValues.add(Integer.toString(softwareModificationReport.getSmrNo()));
                                tableTdValues.add(dateFormat.format(softwareModificationReport.getDate()));
                                tableTdValues.add(softwareModificationReport.getSwTitle());
                                if (sessionBinder.doesUserHasRoule("user")) {
                                   buttonStr = "<input type=hidden value='"+repType+"' name='repType'><input type=hidden value='"+repNo+"' name='scrNo'><input type=submit value='Assign' name='action'>";
                                   tableTdValues.add(buttonStr);
                                }
                                else tableTdValues.add("&nbsp;");
                            }
                        }
                        nextJspPage = "/jsp/smrList.jsp";
                        break;
                    default:
                        request.setAttribute("errorInfo", "Internal Error: Wrong Report Type.");
                        nextJspPage = "/jsp/blank.jsp";
                        break;
                }
                request.setAttribute("tablePrintValues",  null);
                request.setAttribute("tableTdValues", tableTdValues);
            }
            else if (action.equals("Assign")) {
                switch (repType) {
                    case ReportGenerator.SPR_REPORT_TYPE:
                        if (softwareProblemReport.findByPrimaryKey(projectId, sprNo)!=null) {
                            softwareProblemReport.setScrNo(repNo);
                            softwareProblemReport.store();
                        }
                        else {
                            request.setAttribute("errorInfo", "Internal Error: Can not find the SPR: "+sprNo);
                            nextJspPage = "/jsp/blank.jsp";
                        }
                        break;
                    case ReportGenerator.SCR_REPORT_TYPE:
                        if (softwareChangeRequest.findByPrimaryKey(projectId, scrNo)!=null) {
                            softwareChangeRequest.setSmrNo(repNo);
                            softwareChangeRequest.store();
                        }
                        else {
                            request.setAttribute("errorInfo", "Internal Error: Can not find the SCR: "+scrNo);
                            nextJspPage = "/jsp/blank.jsp";
                        }
                        break;
                    default:
                        request.setAttribute("errorInfo", "Internal Error: Wrong Report Type.");
                        nextJspPage = "/jsp/blank.jsp";
                        break;
                }
            }
        } catch (Exception ex) {
            request.setAttribute("errorInfo", ex.toString());
            nextJspPage = "/jsp/blank.jsp";
            ex.printStackTrace();
        }
        
System.out.println("Next page: "+nextJspPage);
        response.setDateHeader("Last-modified", System.currentTimeMillis());
        try {
            request.getRequestDispatcher(nextJspPage).forward(request, response);
        } catch (javax.servlet.ServletException ex) {
            throw ex;
        } catch (java.io.IOException ex) {
            throw new javax.servlet.ServletException(ex);
        }
        
    }//service
}
