/*
 * ReportGenerator.java      Auther: Henrik Baastrup (c) 2003
 *
 * This software is licensed under the GNU LGPL (Lesser general Public License):
 *   http://www.gnu.org/copyleft/lesser.html
 *
 * Created on January 12, 2004, 12:59 PM
 */

package com.hbaastrup.AutoReportGenerator.servlets;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;
import com.hbaastrup.util.*;
import com.hbaastrup.AutoReportGenerator.realm.*;
import com.hbaastrup.AutoReportGenerator.utils.*;
import com.hbaastrup.AutoReportGenerator.dataLayer.*;

public class ReportGenerator extends HttpServlet
{
    public static final int NULL_REPORT_TYPE = 0;
    public static final int SPR_REPORT_TYPE = 1;
    public static final int SCR_REPORT_TYPE = 2;
    public static final int SMR_REPORT_TYPE = 3;
    public static final int CLOSE_STATE = 0;
    public static final int OPEN_STATE = 1;
    public static final int NO_PRI = 0;
    public static final int ROUTINE_PRI = 1;
    public static final int URGENT_PRI = 2;
    public static final int CRITICAL_PRI = 3;
    
    java.text.SimpleDateFormat dateFormat = new java.text.SimpleDateFormat("dd/MM/yyyy");
    
    public ReportGenerator()
    {
    }
    
    protected void  service(HttpServletRequest request, HttpServletResponse response) throws javax.servlet.ServletException
    {
        String nextJspPage = "/jsp/sprProtected.jsp";
        SessionBinder sessionBinder = null;
        SoftwareProblemReport softwareProblemReport = new SoftwareProblemReport();
        SoftwareChangeRequest softwareChangeRequest = new SoftwareChangeRequest();
        SoftwareModificationReport softwareModificationReport = new SoftwareModificationReport();
        Attachments attachments = new Attachments();
        Vector tablePrintValues = new Vector(0);
        Vector tableTdValues = new Vector(0);
        Vector attachmentsVect = new Vector(0);
        HttpSession session = request.getSession(false);
        ReportAttributes reportAttributes = null;
        boolean newAttributes = false;
        int scrNo = 0;
        int smrNo = 0;
        int sortParam = 0;
        String action;
        String str;
        
        if (session==null) {
             javax.servlet.ServletException ex = new javax.servlet.ServletException("The HttpSession for the actual session is null");
             throw ex;
        }
        if ((sessionBinder=(SessionBinder)session.getAttribute("sessionBinder"))==null) {
             javax.servlet.ServletException ex = new  javax.servlet.ServletException("SessionBinder for the actual session is null");
             throw ex;
        }
        ResourceBundle localStrings = (ResourceBundle)session.getAttribute("localStrings");
        
        // Get the parameters for this request
        if ((action=request.getParameter("action"))==null) action = "";
        if ((str=request.getParameter("newAttributes"))!=null) {
            if (str.equals("true") || str.equals("TRUE")) newAttributes = true;
        }
        
        if (action.equals(localStrings.getString("save"))) {
            if ((reportAttributes = (ReportAttributes)session.getAttribute("reportAttributes"))!=null) {
                attachmentsVect = reportAttributes.attachments;
                scrNo = reportAttributes.scrNo;
                smrNo = reportAttributes.smrNo;
            }
            newAttributes = true;
        }
        if (newAttributes) {
            reportAttributes = null;
            session.setAttribute("reportAttributes", null);
        }
        else reportAttributes = (ReportAttributes)session.getAttribute("reportAttributes");
        if (reportAttributes==null) {
            reportAttributes = new ReportAttributes();
            reportAttributes.projectId = sessionBinder.getProjectId();
            if ((str=request.getParameter("repNo"))!=null) {
                if ("".equals(str) || localStrings.getString("notApplyed").equals(str)) reportAttributes.repNo = 0;
                else reportAttributes.repNo = Integer.parseInt(str);
            }
            else reportAttributes.repNo = 0;
            if ((str=request.getParameter("repType"))!=null) {
                if ("".equals(str)) reportAttributes.repType = SPR_REPORT_TYPE;
                else reportAttributes.repType = Integer.parseInt(str);
            }
            else reportAttributes.repType = SPR_REPORT_TYPE;
            if ((str=request.getParameter("date"))!=null) reportAttributes.date = str.trim();
            if ((str=request.getParameter("originator"))!=null) reportAttributes.originator = str.trim();
            if ((str=request.getParameter("state"))!=null) {
System.out.println("state = "+str);
                if (str.equals("Close")) reportAttributes.state = CLOSE_STATE;
                else reportAttributes.state = OPEN_STATE;
            }
            if ((str=request.getParameter("scrNo"))!=null) {
                if ("".equals(str) || localStrings.getString("notApplyed").equals(str)) reportAttributes.scrNo = 0;
                else reportAttributes.scrNo = Integer.parseInt(str);
            }
            else reportAttributes.scrNo = 0;
            if ((str=request.getParameter("smrNo"))!=null) {
                if ("".equals(str) || localStrings.getString("notApplyed").equals(str)) reportAttributes.smrNo = 0;
                else reportAttributes.smrNo = Integer.parseInt(str);
            }
            else reportAttributes.smrNo = 0;
            if ((str=request.getParameter("title"))!=null) reportAttributes.title = str.trim();
            if ((str=request.getParameter("swVersion"))!=null) reportAttributes.swVersion = str.trim();
            if ((str=request.getParameter("priority"))!=null) {
                if (str.equals("Critical")) reportAttributes.priority = CRITICAL_PRI;
                else if (str.equals("Urgent")) reportAttributes.priority = URGENT_PRI;
                else reportAttributes.priority = ROUTINE_PRI;
            }
            if ((str=request.getParameter("description"))!=null) reportAttributes.description = str.trim();
            if ((str=request.getParameter("changeRequired"))!=null) reportAttributes.changeRequired = str.trim();
            if ((str=request.getParameter("changeImplemented"))!=null) reportAttributes.changeImplemented = str.trim();
            if ((str=request.getParameter("environment"))!=null) reportAttributes.environment = str.trim();
            if ((str=request.getParameter("responsibleStaff"))!=null) reportAttributes.responsibleStaff = str.trim();
            if ((str=request.getParameter("decision"))!=null) reportAttributes.decision = str.trim();
            if ((str=request.getParameter("startDate"))!=null) reportAttributes.startDate = str.trim();
            if ((str=request.getParameter("endDate"))!=null) reportAttributes.endDate = str.trim();
            if ((str=request.getParameter("manpower"))!=null) reportAttributes.manpower = str.trim();
            if ((str=request.getParameter("solution"))!=null) reportAttributes.solution = str.trim();
            if ((str=request.getParameter("sortParam"))!=null) sortParam = Integer.parseInt(str);
            reportAttributes.attachments = attachmentsVect;
            reportAttributes.scrNo = scrNo;
            reportAttributes.smrNo = smrNo;
        }
        
System.out.println("ReportGenerator Action="+action);
System.out.println("ReportGenerator Report type="+reportAttributes.repType);
        try {
            
            // Try to parse some dates
            java.sql.Timestamp tsDate;
            if (!"".equals(reportAttributes.date)) tsDate = new java.sql.Timestamp(dateFormat.parse(reportAttributes.date).getTime());
            else tsDate = new java.sql.Timestamp(0);
            java.sql.Timestamp tsStartDate;
            if (!"".equals(reportAttributes.startDate)) tsStartDate = new java.sql.Timestamp(dateFormat.parse(reportAttributes.startDate).getTime());
            else tsStartDate = new java.sql.Timestamp(0);
            java.sql.Timestamp tsEndDate;
            if (!"".equals(reportAttributes.endDate)) tsEndDate = new java.sql.Timestamp(dateFormat.parse(reportAttributes.endDate).getTime());
            else tsEndDate = new java.sql.Timestamp(0);
            
            // Lets have some action
            if (action.equals("DownloadFile")) {
                int attachId = 0;
                ByteArrayDataSource dsFound = null;
                
                if ((action=request.getParameter("oldAction"))==null) action = "";
System.out.println("action changed to: "+action);
                if ((str=request.getParameter("attachId"))!=null) attachId = Integer.parseInt(str);
                for (int i=0; i<reportAttributes.attachments.size(); i++) {
                    ByteArrayDataSource ds = (ByteArrayDataSource)reportAttributes.attachments.get(i);
                    if (ds.getId()==attachId) {dsFound = ds; break;}
                }
                if (dsFound!=null) {
System.out.println("downloading: "+dsFound.getName()+"   id="+dsFound.getId());
                    response.setContentLength(dsFound.getLength());
                    response.setContentType(dsFound.getContentType());
                    ServletOutputStream out = response.getOutputStream();
                    out.write(dsFound.getBytes());
                    return;
                }
            }
            if (action.equals(localStrings.getString("attachFiles"))) {
                session.setAttribute("reportAttributes",  reportAttributes);
                nextJspPage = "/Attachment";
                request.getRequestDispatcher(nextJspPage).forward(request, response);
                return;
            }
            else if (action.equals(localStrings.getString("assignScr")) || action.equals(localStrings.getString("assignSmr"))) {
                session.setAttribute("reportAttributes",  null);
                nextJspPage = "RepAssign?action=List";
                request.getRequestDispatcher(nextJspPage).forward(request, response);
                return;
            }
            else if (action.equals(localStrings.getString("sendEmail"))) {
                session.setAttribute("reportAttributes",  reportAttributes);
                request.setAttribute("fromAddr", sessionBinder.getEMail());
                nextJspPage = "Mailer";
                request.getRequestDispatcher(nextJspPage).forward(request, response);
                return;
            }
            else if (action.equals("New")) {
                session.setAttribute("reportAttributes",  null);
                reportAttributes.originator = sessionBinder.getUserInitials();
                reportAttributes.swVersion = sessionBinder.getProjectSwVersion();
                if (sessionBinder.doesUserHasRoule("user")) {
                    switch (reportAttributes.repType) {
                        default:
                        case SPR_REPORT_TYPE:
                            nextJspPage = "/jsp/sprInput.jsp";
                            break;
                        case SCR_REPORT_TYPE:
                            nextJspPage = "/jsp/scrInput.jsp";
                            break;
                        case SMR_REPORT_TYPE:
                            nextJspPage = "/jsp/smrInput.jsp";
                            break;
                    }
                }
                else {
                    request.setAttribute("errorInfo", "ERROR: The user does not have change permision");
                    nextJspPage = "/jsp/blank.jsp";
                }
            }
            else if (action.equals("FromAttachment")) {
                if (sessionBinder.doesUserHasRoule("user")) {
                    switch (reportAttributes.repType) {
                        default:
                        case SPR_REPORT_TYPE:
                            nextJspPage = "/jsp/sprInput.jsp";
                            break;
                        case SCR_REPORT_TYPE:
                            nextJspPage = "/jsp/scrInput.jsp";
                            break;
                        case SMR_REPORT_TYPE:
                            nextJspPage = "/jsp/smrInput.jsp";
                            break;
                    }
                }
                else {
                    request.setAttribute("errorInfo", "ERROR: The user does not have change permision");
                    nextJspPage = "/jsp/blank.jsp";
                }
            }
            else if (action.equals("List")) {
                int sortParm1=0, sortParm2=0, sortParm3=0;
                if ((str=request.getParameter("sortParm1"))!=null) sortParm1 = Integer.parseInt(str);
                if ((str=request.getParameter("sortParm2"))!=null) sortParm2 = Integer.parseInt(str);
                if ((str=request.getParameter("sortParm3"))!=null) sortParm3 = Integer.parseInt(str);
                if (sortParm1==1) {
                    if ((sortParam & 1)==1) sortParam &= 0xE;
                    else sortParam |= 1;
                }
                if (sortParm2==1) {
                    if ((sortParam & 2)==2) sortParam &= 0xD;
                    else sortParam |= 2;
                }
                if (sortParm3==1) {
                    if ((sortParam & 4)==4) sortParam &= 0xB;
                    else sortParam |= 4;
                }
                Vector tablePrintSortValues = new Vector(0);
                tablePrintSortValues.add(Integer.toString(sortParam));
                if ((sortParam & 1)==1) tablePrintSortValues.add("<img src='/arg/jsp/images/sort.gif' border='0'>");
                else tablePrintSortValues.add("<img src='/arg/jsp/images/noSort.gif' border='0'>");
                if ((sortParam & 2)==2) tablePrintSortValues.add("<img src='/arg/jsp/images/sort.gif' border='0'>");
                else tablePrintSortValues.add("<img src='/arg/jsp/images/noSort.gif' border='0'>");
                if ((sortParam & 4)==4) tablePrintSortValues.add("<img src='/arg/jsp/images/sort.gif' border='0'>");
                else tablePrintSortValues.add("<img src='/arg/jsp/images/noSort.gif' border='0'>");
                    
                Collection coll;
                session.setAttribute("reportAttributes",  null);
                switch (reportAttributes.repType) {
                    default:
                    case SPR_REPORT_TYPE:
                        if ((coll=softwareProblemReport.findByProjectId(reportAttributes.projectId))!=null) {
                            SortablyArrayList arr = new SortablyArrayList(coll);
                            switch (sortParam) {
                                case 1: arr.sortBy("Date", false, "SprNo", false); break;
                                case 2: arr.sortBy("SwTitle", true, "SprNo", false); break;
                                case 3: arr.sortBy("Date", false, "SwTitle", false, "SprNo", true); break;
                                case 4: arr.sortBy("State", false, "SprNo", false); break;
                                case 5: arr.sortBy("Date", false, "State", false, "SprNo", false); break;
                                case 6: arr.sortBy("SwTitle", true, "State", false, "SprNo", false); break;
                                case 7: arr.sortBy("Date", false, "SwTitle", true, "State", false, "SprNo", false); break;
                            }
                            Iterator iter = arr.iterator();
                            while (iter.hasNext()) {
                                softwareProblemReport = (SoftwareProblemReport)iter.next();
                                tableTdValues.add("SPR");
                                tableTdValues.add(Integer.toString(reportAttributes.repType));
                                tableTdValues.add(Integer.toString(softwareProblemReport.getSprNo()));
                                tableTdValues.add(Integer.toString(softwareProblemReport.getSprNo()));
                                tableTdValues.add(dateFormat.format(softwareProblemReport.getDate()));
                                tableTdValues.add(softwareProblemReport.getSwTitle());
                                if (softwareProblemReport.getState()==CLOSE_STATE) tableTdValues.add(localStrings.getString("close"));
                                else tableTdValues.add(localStrings.getString("open"));
                                String buttonStr = "&nbsp;<input type=submit value='"+localStrings.getString("show")+"' name='action'>&nbsp;";
                                if (sessionBinder.doesUserHasRoule("user")) buttonStr += "<input type=submit value='"+localStrings.getString("edit")+"' name='action'>&nbsp;";
                                tableTdValues.add(buttonStr);
                            }
                        }
                        nextJspPage = "/jsp/sprList.jsp";
                        break;
                    case SCR_REPORT_TYPE:
                        if ((coll=softwareChangeRequest.findByProjectId(reportAttributes.projectId))!=null) {
                            SortablyArrayList arr = new SortablyArrayList(coll);
                            switch (sortParam) {
                                case 1: arr.sortBy("Date", false, "ScrNo", false); break;
                                case 2: arr.sortBy("SwTitle", true, "ScrNo", false); break;
                                case 3: arr.sortBy("Date", false, "SwTitle", true, "ScrNo", false); break;
                                case 4: arr.sortBy("State", false, "ScrNo", false); break;
                                case 5: arr.sortBy("Date", false, "State", false, "ScrNo", false); break;
                                case 6: arr.sortBy("SwTitle", true, "State", false, "ScrNo", false); break;
                                case 7: arr.sortBy("Date", false, "SwTitle", true, "State", false, "ScrNo", false); break;
                            }
                            Iterator iter = arr.iterator();
                            while (iter.hasNext()) {
                                softwareChangeRequest = (SoftwareChangeRequest)iter.next();
                                tableTdValues.add("SCR");
                                tableTdValues.add(Integer.toString(reportAttributes.repType));
                                tableTdValues.add(Integer.toString(softwareChangeRequest.getScrNo()));
                                tableTdValues.add(Integer.toString(softwareChangeRequest.getScrNo()));
                                tableTdValues.add(dateFormat.format(softwareChangeRequest.getDate()));
                                tableTdValues.add(softwareChangeRequest.getSwTitle());
                                if (softwareChangeRequest.getState()==CLOSE_STATE) tableTdValues.add(localStrings.getString("close"));
                                else tableTdValues.add(localStrings.getString("Open"));
                                String buttonStr = "&nbsp;<input type=submit value='"+localStrings.getString("show")+"' name='action'>&nbsp;";
                                if (sessionBinder.doesUserHasRoule("user")) buttonStr += "<input type=submit value='"+localStrings.getString("edit")+"' name='action'>&nbsp;";
                                tableTdValues.add(buttonStr);
                            }
                        }
                        nextJspPage = "/jsp/scrList.jsp";
                        break;
                    case SMR_REPORT_TYPE:
                        if ((coll=softwareModificationReport.findByProjectId(reportAttributes.projectId))!=null) {
                            SortablyArrayList arr = new SortablyArrayList(coll);
                            switch (sortParam) {
                                case 1: arr.sortBy("Date", false, "SmrNo", false); break;
                                case 2: arr.sortBy("SwTitle", true, "SmrNo", false); break;
                                case 3: arr.sortBy("Date", false, "SwTitle", true, "SmrNo", false); break;
                            }
                            Iterator iter = arr.iterator();
                            while (iter.hasNext()) {
                                softwareModificationReport = (SoftwareModificationReport)iter.next();
                                tableTdValues.add("SMR");
                                tableTdValues.add(Integer.toString(reportAttributes.repType));
                                tableTdValues.add(Integer.toString(softwareModificationReport.getSmrNo()));
                                tableTdValues.add(Integer.toString(softwareModificationReport.getSmrNo()));
                                tableTdValues.add(dateFormat.format(softwareModificationReport.getDate()));
                                tableTdValues.add(softwareModificationReport.getSwTitle());
                                String buttonStr = "&nbsp;<input type=submit value='"+localStrings.getString("show")+"' name='action'>&nbsp;";
                                if (sessionBinder.doesUserHasRoule("user")) buttonStr += "<input type=submit value='"+localStrings.getString("edit")+"' name='action'>&nbsp;";
                                tableTdValues.add(buttonStr);
                            }
                        }
                        nextJspPage = "/jsp/smrList.jsp";
                        break;
                }
                request.setAttribute("tablePrintSortValues", tablePrintSortValues);
                request.setAttribute("tableTdValues", tableTdValues);
            }
            else if (action.equals("Save") && sessionBinder.doesUserHasRoule("user")) {
                boolean createRec = false;
                boolean saveRec = true;
                
                if ("".equals(reportAttributes.date)) {
                    request.setAttribute("errorInfo", "ERROR: The Date field is required");
                    saveRec = false;
                }
                if ("".equals(reportAttributes.originator.trim())) {
                    request.setAttribute("errorInfo", "ERROR: The Originator field is required");
                    saveRec = false;
                }
                if ("".equals(reportAttributes.title.trim())) {
                    request.setAttribute("errorInfo", "ERROR: The Software Item Title field is required");
                    saveRec = false;
                }
                switch (reportAttributes.repType) {
                    default:
                    case SPR_REPORT_TYPE:
                        if ("".equals(reportAttributes.description.trim())) {
                            request.setAttribute("errorInfo", "ERROR: The Problem Description field is required");
                            saveRec = false;
                        }
                        if (saveRec && softwareProblemReport.findByPrimaryKey(reportAttributes.projectId, reportAttributes.repNo)==null) {
                            SequenceKeys sequenceKeys = new SequenceKeys();
                            reportAttributes.repNo = sequenceKeys.getNextSequence(reportAttributes.projectId,"Software_Problem_Report");
                            softwareProblemReport = new SoftwareProblemReport(reportAttributes.projectId, reportAttributes.repNo);
                            createRec = true;
                        }
                        softwareProblemReport.setDate(tsDate);
                        softwareProblemReport.setOriginator(reportAttributes.originator);
                        softwareProblemReport.setState(reportAttributes.state);
                        softwareProblemReport.setSwTitle(reportAttributes.title);
                        softwareProblemReport.setSwVersion(reportAttributes.swVersion);
                        softwareProblemReport.setPriority(reportAttributes.priority);
                        softwareProblemReport.setProblemDescription(reportAttributes.description);
                        softwareProblemReport.setEnvironment(reportAttributes.environment);
                        softwareProblemReport.setRecommendedSolution(reportAttributes.solution);
                        softwareProblemReport.setSrbDecision(reportAttributes.decision);
                        if (saveRec) {
                            if (createRec) softwareProblemReport.create();
                            else softwareProblemReport.store();
                        }
                        nextJspPage = "/jsp/sprInput.jsp";
                        break;
                    case SCR_REPORT_TYPE:
                        if ("".equals(reportAttributes.changeRequired.trim())) {
                            request.setAttribute("errorInfo", "ERROR: The Changes Required field is required");
                            saveRec = false;
                        }
                        if (saveRec && softwareChangeRequest.findByPrimaryKey(reportAttributes.projectId, reportAttributes.repNo)==null) {
                            SequenceKeys sequenceKeys = new SequenceKeys();
                            reportAttributes.repNo = sequenceKeys.getNextSequence(reportAttributes.projectId,"Software_Change_Request");
                            softwareChangeRequest = new SoftwareChangeRequest(reportAttributes.projectId, reportAttributes.repNo);
                            createRec = true;
                        }
                        softwareChangeRequest.setDate(tsDate);
                        softwareChangeRequest.setOriginator(reportAttributes.originator);
                        softwareChangeRequest.setState(reportAttributes.state);
                        softwareChangeRequest.setSwTitle(reportAttributes.title);
                        softwareChangeRequest.setSwVersion(reportAttributes.swVersion);
                        softwareChangeRequest.setPriority(reportAttributes.priority);
                        softwareChangeRequest.setChangeRequired(reportAttributes.changeRequired);
                        softwareChangeRequest.setResponsibleStaff(reportAttributes.responsibleStaff);
                        softwareChangeRequest.setStartDate(tsStartDate);
                        softwareChangeRequest.setEndDate(tsEndDate);
                        softwareChangeRequest.setManpower(reportAttributes.manpower);
                        if (saveRec) {
                            if (createRec) softwareChangeRequest.create();
                            else softwareChangeRequest.store();
                        }
                        nextJspPage = "/jsp/scrInput.jsp";
                        break;
                    case SMR_REPORT_TYPE:
                        if ("".equals(reportAttributes.changeImplemented.trim())) {
                            request.setAttribute("errorInfo", "ERROR: The Changes Implemented field is required");
                            saveRec = false;
                        }
                        if (saveRec && softwareModificationReport.findByPrimaryKey(reportAttributes.projectId, reportAttributes.repNo)==null) {
                            SequenceKeys sequenceKeys = new SequenceKeys();
                            reportAttributes.repNo = sequenceKeys.getNextSequence(reportAttributes.projectId,"Software_Modification_Report");
                            softwareModificationReport = new SoftwareModificationReport(reportAttributes.projectId, reportAttributes.repNo);
                            createRec = true;
                        }
                        softwareModificationReport.setDate(tsDate);
                        softwareModificationReport.setOriginator(reportAttributes.originator);
                        softwareModificationReport.setSwTitle(reportAttributes.title);
                        softwareModificationReport.setSwVersion(reportAttributes.swVersion);
                        softwareModificationReport.setChangeImplemented(reportAttributes.changeImplemented);
                        softwareModificationReport.setStartDate(tsStartDate);
                        softwareModificationReport.setEndDate(tsEndDate);
                        softwareModificationReport.setManpower(reportAttributes.manpower);
                        if (saveRec) {
                            if (createRec) softwareModificationReport.create();
                            else softwareModificationReport.store();
                        }
                        nextJspPage = "/jsp/smrInput.jsp";
                        break;
                }
                
                //attachments
                if (saveRec) for (int i=0; i<reportAttributes.attachments.size(); i++) {
                    ByteArrayDataSource ds = (ByteArrayDataSource)reportAttributes.attachments.get(i);
System.out.println("   "+ds.getName()+" selected="+ds.isSelected());
                    if (ds.isSelected() && ds.getId()==0) {
                        SequenceKeys sequenceKeys = new SequenceKeys();
                        int id = sequenceKeys.getNextSequence(reportAttributes.projectId, "Attachments");
                        ds.setId(id);
                        Attachments attachment = new Attachments(reportAttributes.projectId, ds.getId());
                        attachment.setReportNo(reportAttributes.repNo);
                        attachment.setReportType(reportAttributes.repType);
                        attachment.setFilename(ds.getName());
                        attachment.setAttachment(ds.getBytes());
                        attachment.create();
                    }
                    else if (!ds.isSelected() && ds.getId()!=0) {
                        Attachments attachment = new Attachments(reportAttributes.projectId, ds.getId());
                        attachment.remove();
                    }
                }
                session.setAttribute("reportAttributes",  reportAttributes);
            }
            else if (action.equals(localStrings.getString("delete")) && sessionBinder.doesUserHasRoule("administrator")) {
                switch (reportAttributes.repType) {
                    case SPR_REPORT_TYPE:
                        softwareProblemReport = new SoftwareProblemReport(reportAttributes.projectId, reportAttributes.repNo);
                        softwareProblemReport.remove();
                        attachments.removeByProjectIdReportNoReportType(reportAttributes.projectId, reportAttributes.repNo, reportAttributes.repType);
                        request.setAttribute("errorInfo", localStrings.getString("reportDeleted"));
                        break;
                    case SCR_REPORT_TYPE:
                        softwareChangeRequest = new SoftwareChangeRequest(reportAttributes.projectId, reportAttributes.repNo);
                        softwareChangeRequest.remove();
                        attachments.removeByProjectIdReportNoReportType(reportAttributes.projectId, reportAttributes.repNo, reportAttributes.repType);
                        request.setAttribute("errorInfo", localStrings.getString("reportDeleted"));
                        break;
                    case SMR_REPORT_TYPE:
                        softwareModificationReport = new SoftwareModificationReport(reportAttributes.projectId, reportAttributes.repNo);
                        softwareModificationReport.remove();
                        attachments.removeByProjectIdReportNoReportType(reportAttributes.projectId, reportAttributes.repNo, reportAttributes.repType);
                        request.setAttribute("errorInfo", localStrings.getString("reportDeleted"));
                        break;
                    default:
                        request.setAttribute("errorInfo", "ERROR: Wrong type of report. Nothing was deleted");
                }
                nextJspPage = "/jsp/blank.jsp";
                session.setAttribute("reportAttributes",  null);
            }
            else if (action.equals(localStrings.getString("show")) || action.equals(localStrings.getString("edit"))) {
                
                int reportType = reportAttributes.repType;
                int reportNo = reportAttributes.repNo;
                reportAttributes = new ReportAttributes();
                switch (reportType) {
                    default:
                    case SPR_REPORT_TYPE:
                        if (softwareProblemReport.findByPrimaryKey(sessionBinder.getProjectId(), reportNo)!=null) {
                            reportAttributes.date = dateFormat.format(softwareProblemReport.getDate());
                            reportAttributes.originator = softwareProblemReport.getOriginator();
                            reportAttributes.state = softwareProblemReport.getState();
                            reportAttributes.scrNo = softwareProblemReport.getScrNo();
                            reportAttributes.title = softwareProblemReport.getSwTitle();
                            reportAttributes.swVersion = softwareProblemReport.getSwVersion();
                            reportAttributes.priority = softwareProblemReport.getPriority();
                            reportAttributes.description = softwareProblemReport.getProblemDescription();
                            reportAttributes.environment = softwareProblemReport.getEnvironment();
                            reportAttributes.solution = softwareProblemReport.getRecommendedSolution();
                            reportAttributes.decision = softwareProblemReport.getSrbDecision();
                        }
                        if (action.equals(localStrings.getString("edit")) && sessionBinder.doesUserHasRoule("user")) nextJspPage = "/jsp/sprInput.jsp";
                        else nextJspPage = "/jsp/sprProtected.jsp";
                        break;
                    case SCR_REPORT_TYPE:
                        if (softwareChangeRequest.findByPrimaryKey(sessionBinder.getProjectId(), reportNo)!=null) {
                            reportAttributes.date = dateFormat.format(softwareChangeRequest.getDate());
                            reportAttributes.originator = softwareChangeRequest.getOriginator();
                            reportAttributes.state = softwareChangeRequest.getState();
                            reportAttributes.smrNo = softwareChangeRequest.getSmrNo();
                            reportAttributes.title = softwareChangeRequest.getSwTitle();
                            reportAttributes.swVersion = softwareChangeRequest.getSwVersion();
                            reportAttributes.priority = softwareChangeRequest.getPriority();
                            reportAttributes.changeRequired = softwareChangeRequest.getChangeRequired();
                            reportAttributes.responsibleStaff = softwareChangeRequest.getResponsibleStaff();
                            reportAttributes.startDate = dateFormat.format(softwareChangeRequest.getStartDate());
                            reportAttributes.endDate = dateFormat.format(softwareChangeRequest.getEndDate());
                            reportAttributes.manpower = softwareChangeRequest.getManpower();
                        }
                        if (action.equals(localStrings.getString("edit")) && sessionBinder.doesUserHasRoule("user")) nextJspPage = "/jsp/scrInput.jsp";
                        else nextJspPage = "/jsp/scrProtected.jsp";
                        break;
                    case SMR_REPORT_TYPE:
                        if (softwareModificationReport.findByPrimaryKey(sessionBinder.getProjectId(), reportNo)!=null) {
                            reportAttributes.date = dateFormat.format(softwareModificationReport.getDate());
                            reportAttributes.originator = softwareModificationReport.getOriginator();
                            reportAttributes.title = softwareModificationReport.getSwTitle();
                            reportAttributes.swVersion = softwareModificationReport.getSwVersion();
                            reportAttributes.changeImplemented = softwareModificationReport.getChangeImplemented();
                            reportAttributes.startDate = dateFormat.format(softwareModificationReport.getStartDate());
                            reportAttributes.endDate = dateFormat.format(softwareModificationReport.getEndDate());
                            reportAttributes.manpower = softwareModificationReport.getManpower();
                        }
                        if (action.equals(localStrings.getString("edit")) && sessionBinder.doesUserHasRoule("user")) nextJspPage = "/jsp/smrInput.jsp";
                        else nextJspPage = "/jsp/smrProtected.jsp";
                        break;
                }
                reportAttributes.projectId = sessionBinder.getProjectId();
                reportAttributes.repType = reportType;
                reportAttributes.repNo = reportNo;
                
                //Attachments
                attachments = new Attachments();
                Collection coll;
System.out.println("  Attachments:");
                if ((coll=attachments.findByProjectIdReportNoReportType(reportAttributes.projectId, reportAttributes.repNo, reportAttributes.repType))!=null) {
                    Iterator iter = coll.iterator();
                    while (iter.hasNext()) {
                        attachments = (Attachments)iter.next();
                        ByteArrayDataSource ds = new ByteArrayDataSource(attachments.getAttachmentBinary(), null, attachments.getFileName(), attachments.getAttachmentId());
System.out.println("     "+ds.getName());
                        reportAttributes.attachments.add(ds);
                    }
                }
                session.setAttribute("reportAttributes",  reportAttributes);
            }
            else {
                session.setAttribute("reportAttributes",  null);
                nextJspPage = "/jsp/blank.jsp";
            }
            
        } catch (Exception ex) {
            request.setAttribute("errorInfo", ex.toString());
            nextJspPage = "/jsp/blank.jsp";
            ex.printStackTrace();
        }
        
        if (reportAttributes.repNo==0) tablePrintValues.add(localStrings.getString("notApplyed"));
        else tablePrintValues.add(Integer.toString(reportAttributes.repNo));
        tablePrintValues.add(Integer.toString(reportAttributes.repType));
        tablePrintValues.add(reportAttributes.date);
        tablePrintValues.add(reportAttributes.originator);
        switch (reportAttributes.repType) {
            default:
            case SPR_REPORT_TYPE:
                if (reportAttributes.scrNo==0) tablePrintValues.add(localStrings.getString("notApplyed"));
                else {
                    String hrefStr = "/arg/SCR?repType="+SCR_REPORT_TYPE+"&projectId="+reportAttributes.projectId+"&repNo="+reportAttributes.scrNo+"&action=Show&newAttributes=true";
                    tablePrintValues.add("<a href='"+hrefStr+"'>"+reportAttributes.scrNo+"</a>");
                }
                tablePrintValues.add(reportAttributes.title);
                tablePrintValues.add(reportAttributes.swVersion);
                tablePrintValues.add(reportAttributes.description);
                tablePrintValues.add(reportAttributes.environment);
                tablePrintValues.add(reportAttributes.solution);
                tablePrintValues.add(reportAttributes.decision);
                if (reportAttributes.attachments==null) tablePrintValues.add("&nbsp;");
                else {
                    StringBuffer strBuf = new StringBuffer("");
                    for (int i=0; i<reportAttributes.attachments.size(); i++) {
                        ByteArrayDataSource ds = (ByteArrayDataSource)reportAttributes.attachments.get(i);
                        if (ds.isSelected()) strBuf.append("&nbsp;-&nbsp;<a href='/arg/SPR?action=DownloadFile&attachId="+ds.getId()+"&oldAction="+action+"'>"+ds.getName()+"</a>&nbsp;("+ds.getLength()+" bytes)<br>");
                    }
                    tablePrintValues.add(strBuf.toString());
                }
                switch (reportAttributes.priority) {
                    default:
                    case 1: request.setAttribute("priority", localStrings.getString("routine")); break;
                    case 2: request.setAttribute("priority", localStrings.getString("urgent")); break;
                    case 3: request.setAttribute("priority", localStrings.getString("critical")); break;
                }
                break;
            case SCR_REPORT_TYPE:
                if (reportAttributes.smrNo==0) tablePrintValues.add(localStrings.getString("notApplyed"));
                else {
                     String hrefStr = "/arg/SMR?repType="+SMR_REPORT_TYPE+"&projectId="+reportAttributes.projectId+"&repNo="+reportAttributes.smrNo+"&action=Show&newAttributes=true";
                    tablePrintValues.add("<a href='"+hrefStr+"'>"+reportAttributes.smrNo+"</a>");
                }
                tablePrintValues.add(reportAttributes.title);
                tablePrintValues.add(reportAttributes.swVersion);
                tablePrintValues.add(reportAttributes.changeRequired);
                tablePrintValues.add(reportAttributes.responsibleStaff);
                tablePrintValues.add(reportAttributes.startDate);
                tablePrintValues.add(reportAttributes.endDate);
                tablePrintValues.add(reportAttributes.manpower);
                if (reportAttributes.attachments==null) tablePrintValues.add("&nbsp;");
                else {
                    StringBuffer strBuf = new StringBuffer("");
                    for (int i=0; i<reportAttributes.attachments.size(); i++) {
                        ByteArrayDataSource ds = (ByteArrayDataSource)reportAttributes.attachments.get(i);
                        if (ds.isSelected()) strBuf.append("&nbsp;-&nbsp;<a href='/arg/SCR?action=DownloadFile&attachId="+ds.getId()+"&oldAction="+action+"'>"+ds.getName()+"</a>&nbsp;("+ds.getLength()+" bytes)<br>");
                    }
                    tablePrintValues.add(strBuf.toString());
                }
                switch (reportAttributes.priority) {
                    default:
                    case 1: request.setAttribute("priority", localStrings.getString("routine")); break;
                    case 2: request.setAttribute("priority", localStrings.getString("urgent")); break;
                    case 3: request.setAttribute("priority", localStrings.getString("critical")); break;
                }
                break;
            case SMR_REPORT_TYPE:
                tablePrintValues.add(reportAttributes.title);
                tablePrintValues.add(reportAttributes.swVersion);
                tablePrintValues.add(reportAttributes.changeImplemented);
                tablePrintValues.add(reportAttributes.startDate);
                tablePrintValues.add(reportAttributes.endDate);
                tablePrintValues.add(reportAttributes.manpower);
                if (reportAttributes.attachments==null) tablePrintValues.add("&nbsp;");
                else {
                    StringBuffer strBuf = new StringBuffer("");
                    for (int i=0; i<reportAttributes.attachments.size(); i++) {
                        ByteArrayDataSource ds = (ByteArrayDataSource)reportAttributes.attachments.get(i);
                        if (ds.isSelected()) strBuf.append("&nbsp;-&nbsp;<a href='/arg/SPR?action=DownloadFile&attachId="+ds.getId()+"&oldAction="+action+"'>"+ds.getName()+"</a>&nbsp;("+ds.getLength()+" bytes)<br>");
                    }
                    tablePrintValues.add(strBuf.toString());
                }
                break;
        }
        request.setAttribute("tablePrintValues", tablePrintValues);
        if (reportAttributes.state==CLOSE_STATE) request.setAttribute("state", localStrings.getString("close"));
        else request.setAttribute("state", localStrings.getString("open"));
System.out.println("ReportGenerator Next page: "+nextJspPage);
        response.setDateHeader("Last-modified", System.currentTimeMillis());
        try {
            request.getRequestDispatcher(nextJspPage).forward(request, response);
        } catch (javax.servlet.ServletException ex) {
            throw ex;
        } catch (java.io.IOException ex) {
            throw new javax.servlet.ServletException(ex);
        }
    }//service
}//ProblemReport
