/*
 * Filename ByteArrayDataSource.java   Auther: Henrik Baastrup (c) 2001
 *
 * This software is licensed under the GNU LGPL (Lesser general Public License):
 *   http://www.gnu.org/copyleft/lesser.html
 *
 */

package com.hbaastrup.AutoReportGenerator.utils;

import java.io.InputStream;
import java.io.OutputStream;
import java.io.IOException;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.FileNotFoundException;
import javax.activation.DataSource;

public class ByteArrayDataSource implements DataSource
{
    byte[] bytes = null;
    String contentType = null;
    String name = null;
    int id = 0;
    boolean selected = true;
    boolean tuched = true;

    public ByteArrayDataSource(byte[] bytes, String contentType, String name)
    {
        init(bytes, contentType, name);
    }//ByteArrayDataSource+

    public ByteArrayDataSource(byte[] bytes, String contentType, String name, int id)
    {
        init(bytes, contentType, name);
        this.id = id;
    }//ByteArrayDataSource
    
    private void init(byte[] bytes, String contentType, String name)
    {
        this.bytes = bytes;
        if (null == contentType) this.contentType = "application/octet-stream";
        else this.contentType = contentType;
        this.name = name;
    }//init

    public String getContentType() {return contentType;}

    public String getName() {return name;}
    
    public int getId() {return id;}
    public void setId(int id) {this.id = id;}

    public int getLength() {return bytes.length-2;}

    public byte[] getBytes() {return bytes;}
    
    public InputStream getInputStream()
    {
        return new ByteArrayInputStream(bytes, 0, bytes.length-2);
    }//getInputStream

    public OutputStream getOutputStream() throws java.io.IOException
    {
        throw new FileNotFoundException();
    }//getOutputStream

    public void setSelected(boolean b) {selected = b; tuched = true;}
    public boolean getSelected() {return selected;}
    public boolean isSelected() {return selected;}
    public boolean isTuched() {return tuched;}
    public void unTuch() {tuched = false;}
}//ByteArrayDataSource
