/*
 * PagePrintTag.java
 *
 * Created on February 20, 2003, 4:41 PM
 *
The <page-print> the tag expect that either the tablePrintValues attribute or the
valuePasserAttr attribute are set. These attributes are either set in the request class or
in the session class. The tag control, first the request class, then the session class for
the attribute. The attribute must contain a Vector class, containing a vector of String
classes.
The tag take the following attributes:
valuePasserAttr='attribute' Optional. This attribute give the possibility to pass values other
                            than the default attribute (tablePrintValues). This attribute is
                            used when there exist more than one table-td tag on a page.

The tag try to interpret the body of the tag and substitute dollar sign ($) with the values
from the passed attribute. The body, with the substituted values, will be send to the to the
output stream.

<page-print [valuePasserAttr='attribute']>
{$}
</page-print>

Example:
A servlet or a JSP as set the attribute tablePrintValues in either the request class or the
session class with the values {"Henrik", "Baastrup"}
Our JSP:
<table border='1'>
<arc3tag:page-print>
<tr><td>Name:</td><td><input type=text value='$' name='name'></td></tr>
<tr><td>Sir Name:</td><td><input type=text value='$' name='sirname'></td></tr>
<arc3tag:page-print>
</table>
Output:
<table border='1'>
<tr><td>Name:</td><td><input type=text value='Henrik' name='name'></td></tr>
<tr><td>Sir Name:</td><td><input type=text value='Baastrup' name='sirname'></td></tr>
</table>
 *
 */

package com.hbaastrup.tagLib;
import javax.servlet.jsp.*;
import javax.servlet.jsp.tagext.*;
import java.util.*;
import java.io.*;

/**
 *
 * @author  Henrik Baastrup (c)
 */
public class PagePrintTag extends BodyTagSupport
{
    private String valuePasserAttr = "tablePrintValues";
    private Vector tableValues = null;
    
    public PagePrintTag()
    {
        super();
    }//TablePrintTag
    
    public int doStartTag() throws JspException
    {
        return EVAL_BODY_BUFFERED;
    }//doStartTag
    
    public int doEndTag()
    {
        return EVAL_PAGE;
    }//doAfterBody
    
    public int doAfterBody() throws JspException
    {
        BodyContent bodyContent;
        String body;
        String format;
        Vector formatVector = new Vector(0);
        JspWriter out;
        Integer inx1, inx2;
        int i, j;

        if ((bodyContent=getBodyContent())==null) return SKIP_BODY;
        if ((body=bodyContent.getString())==null) return SKIP_BODY;
        
        format = new String(body);
        j = 0;
        do {
            if ((i=format.indexOf('$',j+1)) >= 0) formatVector.addElement(new Integer(i));
            j = i;
        } while (j > 0);

        // Get the actual values
        javax.servlet.ServletRequest request = pageContext.getRequest();
        if ((tableValues=(Vector)request.getAttribute(valuePasserAttr))==null) {
            javax.servlet.http.HttpSession session = pageContext.getSession();
            if ((tableValues=(Vector)session.getAttribute(valuePasserAttr))==null) return SKIP_BODY;
        }
        
        try {
            out = bodyContent.getEnclosingWriter();

            inx1 = new Integer(0);
            Enumeration tabEnum = tableValues.elements();
            Enumeration formEnum = formatVector.elements();
            while (tabEnum.hasMoreElements() && formEnum.hasMoreElements()) {
                String tabVal = (String)tabEnum.nextElement();
                inx2 = (Integer)formEnum.nextElement();
                out.print(format.substring(inx1.intValue()+1, inx2.intValue())+tabVal);
                inx1 = inx2;
            }
            out.print(format.substring(inx1.intValue()+1));
        } catch (Exception ex) {
            throw new JspException("TablePrintTag: "+ex.toString());
        }
            
        return SKIP_BODY;
    }
    
    public void setValuePasserAttr(String aClass) {valuePasserAttr = aClass;}
    public void setValuepasserattr(String aClass) {valuePasserAttr = aClass;}
}//PagePrintTag
