/*
 * TableExpoter.java
 *
 * Created on March 8, 2004, 12:22 PM
 */

package com.hbaastrup.util;
import javax.sql.*;
import java.sql.*;
import java.util.*;
import java.text.*;

/**
 *
 * @author  Henrik Baastrup (c) 2003
 * @version 0.1
 *
 * Home page: http://digilander.iol.it/hba/Linux/index.html
 * This software is licensed under the GNU LGPL (Lesser general Public License):
 *   http://www.gnu.org/copyleft/lesser.html
 *
 */

public class TableExpoter
{
    String driverName = "com.mysql.jdbc.Driver";
    String dbUrl = "jdbc:mysql://itmow234.mo.it.eds.com:3306/AutoReportGenerator";
    String user = "arguser";
    String password = "password";
/*        String driverName = "oracle.jdbc.driver.OracleDriver";
        String dbUrl = "jdbc:oracle:thin:@itmos223:1521:ARC";
        String user = "system";
        String password = "manager";
*/        

    private Connection conn = null;
    SimpleDateFormat df;
    
    public TableExpoter()
    {
        df = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
    }
    
    public Connection createConnection()
    {
        try {
            if (conn!=null) conn.close();
            Class.forName(driverName);
            conn = DriverManager.getConnection(dbUrl, user, password);
        } catch (ClassNotFoundException ex) {
            ex.printStackTrace();
            conn = null;
        } catch (SQLException ex) {
            ex.printStackTrace();
            conn =  null;
        }
        return conn;
    }//createConnection
    
    public boolean exportTable(String tableName, String fileName)
    {
        String sqlStr;
        Statement statement;
        ResultSet resultSet;
        ResultSetMetaData metaData;
        String clumsNames[];
        int numberOfColumns, columsTypes[];
        Object obj;
        StringBuffer outLine;
        java.io.PrintStream out;
        
        sqlStr = "SELECT * FROM "+tableName;
        if (conn==null) if (createConnection()==null) return false;
        try {
            out = new java.io.PrintStream(new java.io.FileOutputStream(fileName));
            if ((statement=conn.createStatement())==null) return false;
            if ((resultSet=statement.executeQuery(sqlStr))==null) return false;
            if ((metaData=resultSet.getMetaData())==null) return false;
            numberOfColumns = metaData.getColumnCount();
            clumsNames = new String[numberOfColumns];
            columsTypes = new int[numberOfColumns];
            for (int i=0; i<numberOfColumns; i++) {
                clumsNames[i] = metaData.getColumnLabel(i+1);
                columsTypes[i] = metaData.getColumnType(i+1);
            }
            
            while (resultSet.next()) {
                outLine = new StringBuffer("INSERT INTO "+tableName+" (");
                outLine.append(clumsNames[0]);
                for (int i=1; i<numberOfColumns; i++) outLine.append(","+clumsNames[i]);
                outLine.append(") VALUES (");
                outLine.append(objectToValueString(resultSet.getObject(1), columsTypes[0]));
                for (int i=2; i<=numberOfColumns; i++) {
                    outLine.append(","+objectToValueString(resultSet.getObject(i), columsTypes[i-1]));
                }
                outLine.append(");");
                out.println(outLine);
            }
            
        } catch (java.sql.SQLException ex) {
            ex.printStackTrace();
            return false;
        } catch (java.io.FileNotFoundException ex) {
            ex.printStackTrace();
            return false;
        }
        return true;
    }//exportTable
    
    private String objectToValueString(Object obj, int type)
    {
        switch (type) {
            case Types.CHAR:
            case Types.VARCHAR:
            case Types.LONGVARCHAR:
                if (obj!=null) return new String("'"+(String)obj+"'");
                else return new String("''");
                
            case Types.TINYINT:
            case Types.SMALLINT:
            case Types.INTEGER:
                if (obj!=null) return new String(((Integer)obj).toString());
                else return new String("null");
                
            case Types.BIGINT:
                if (obj!=null) return new String(((Long)obj).toString());
                else return new String("null");
                
            case Types.FLOAT:
            case Types.DOUBLE:
                if (obj!=null) return new String(((Double)obj).toString());
                else return new String("null");
                
            case Types.DATE:
            case Types.TIME:
            case Types.TIMESTAMP:
                if (obj!=null) return new String("'"+df.format(obj)+"'");
                else return new String("'"+df.format(new Timestamp(0))+"'");
                
            case Types.BINARY:
            case Types.VARBINARY:
            case Types.LONGVARBINARY:
                if (obj!=null) {
                    byte byt[] = (byte[])obj;
                    Base64EncodeDataSource enCoder = new Base64EncodeDataSource(byt, null, "blob");
                    String str = new String(enCoder.getBytes());
                    return new String("'"+str+"'");
                }
                else return new String("''");
                
            case Types.BLOB:
                if (obj!=null) {
                    Class cl = obj.getClass();
                    Blob blob = (Blob)obj;
                    try {
                        String str = new String(blob.getBytes(1,(int)blob.length()));
                        return new String("'"+str+"'");
                    } catch (java.sql.SQLException ex) {
                        ex.printStackTrace();
                        return new String("''");
                    }
                }
                else return new String("''");
                
            default:
                if (obj==null) System.out.println("ERROR Not known NULL object");
                else if (obj.getClass().isInstance(new String())) return new String("'"+(String)obj+"'");
                else System.out.println("ERROR: Not known SQL type: "+type);
     System.out.println("Object name="+obj.getClass().getName());
        }
        
        return new String("");
    }//objectToValueString
    
    
    

    public void setDriverName(String aName) {driverName = aName;}
    public void setDbUrl(String aUrl) {dbUrl = aUrl;}
    public void setUser(String aUser) {user = aUser;};
    public void setPassword(String aPassword) {password = aPassword;}


    public static void main(String[] args)
    {
        String tableName = "Users";
        String fileName = "out.sql";
        TableExpoter te = new TableExpoter();
        
        te.exportTable(tableName, fileName);
    }//main
}//TableExpoter
